/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         FRONTEND_VERILOG_YYSTYPE
#define YYLTYPE         FRONTEND_VERILOG_YYLTYPE
/* Substitute the variable and function names.  */
#define yyparse         frontend_verilog_yyparse
#define yylex           frontend_verilog_yylex
#define yyerror         frontend_verilog_yyerror
#define yydebug         frontend_verilog_yydebug
#define yynerrs         frontend_verilog_yynerrs


/* Copy the first part of user declarations.  */
#line 38 "frontends/verilog/verilog_parser.y" /* yacc.c:339  */

#include <list>
#include <stack>
#include <string.h>
#include "frontends/verilog/verilog_frontend.h"
#include "frontends/verilog/verilog_parser.tab.hh"
#include "kernel/log.h"

#define YYLEX_PARAM &yylval, &yylloc

USING_YOSYS_NAMESPACE
using namespace AST;
using namespace VERILOG_FRONTEND;

YOSYS_NAMESPACE_BEGIN
namespace VERILOG_FRONTEND {
	int port_counter;
	dict<std::string, int> port_stubs;
	dict<IdString, AstNode*> *attr_list, default_attr_list;
	std::stack<dict<IdString, AstNode*> *> attr_list_stack;
	dict<IdString, AstNode*> *albuf;
	std::vector<UserTypeMap> user_type_stack;
	dict<std::string, AstNode*> pkg_user_types;
	std::vector<AstNode*> ast_stack;
	struct AstNode *astbuf1, *astbuf2, *astbuf3;
	struct AstNode *current_function_or_task;
	struct AstNode *current_ast, *current_ast_mod;
	int current_function_or_task_port_id;
	std::vector<char> case_type_stack;
	bool do_not_require_port_stubs;
	bool default_nettype_wire;
	bool sv_mode, formal_mode, lib_mode, specify_mode;
	bool noassert_mode, noassume_mode, norestrict_mode;
	bool assume_asserts_mode, assert_assumes_mode;
	bool current_wire_rand, current_wire_const;
	bool current_modport_input, current_modport_output;
	std::istream *lexin;
}
YOSYS_NAMESPACE_END

#define SET_AST_NODE_LOC(WHICH, BEGIN, END) \
    do { (WHICH)->location.first_line = (BEGIN).first_line; \
    (WHICH)->location.first_column = (BEGIN).first_column; \
    (WHICH)->location.last_line = (END).last_line; \
    (WHICH)->location.last_column = (END).last_column; } while(0)

#define SET_RULE_LOC(LHS, BEGIN, END) \
    do { (LHS).first_line = (BEGIN).first_line; \
    (LHS).first_column = (BEGIN).first_column; \
    (LHS).last_line = (END).last_line; \
    (LHS).last_column = (END).last_column; } while(0)

int frontend_verilog_yylex(YYSTYPE *yylval_param, YYLTYPE *yyloc_param);

static void append_attr(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second;
	}
	delete al;
}

static void append_attr_clone(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second->clone();
	}
}

static void free_attr(dict<IdString, AstNode*> *al)
{
	for (auto &it : *al)
		delete it.second;
	delete al;
}

struct specify_target {
	char polarity_op;
	AstNode *dst, *dat;
};

struct specify_triple {
	AstNode *t_min, *t_avg, *t_max;
};

struct specify_rise_fall {
	specify_triple rise;
	specify_triple fall;
};

static void addWiretypeNode(std::string *name, AstNode *node)
{
	log_assert(node);
	node->is_custom_type = true;
	node->children.push_back(new AstNode(AST_WIRETYPE));
	node->children.back()->str = *name;
	delete name;
}

static void addTypedefNode(std::string *name, AstNode *node)
{
	log_assert(node);
	auto *tnode = new AstNode(AST_TYPEDEF, node);
	tnode->str = *name;
	auto &user_types = user_type_stack.back();
	user_types[*name] = tnode;
	if (current_ast_mod && current_ast_mod->type == AST_PACKAGE) {
		// typedef inside a package so we need the qualified name
		auto qname = current_ast_mod->str + "::" + (*name).substr(1);
		pkg_user_types[qname] = tnode;
	}
	delete name;
	ast_stack.back()->children.push_back(tnode);
}

static void enterTypeScope()
{
	user_type_stack.push_back(UserTypeMap());
}

static void exitTypeScope()
{
	user_type_stack.pop_back();
}

static bool isInLocalScope(const std::string *name)
{
	// tests if a name was declared in the current block scope
	auto &user_types = user_type_stack.back();
	return (user_types.count(*name) > 0);
}

static AstNode *makeRange(int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = new AstNode(AST_RANGE);
	range->children.push_back(AstNode::mkconst_int(msb, true));
	range->children.push_back(AstNode::mkconst_int(lsb, true));
	range->is_signed = isSigned;
	return range;
}

static void addRange(AstNode *parent, int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = makeRange(msb, lsb, isSigned);
	parent->children.push_back(range);
}

static AstNode *checkRange(AstNode *type_node, AstNode *range_node)
{
	if (type_node->range_left >= 0 && type_node->range_right >= 0) {
		// type already restricts the range
		if (range_node) {
			frontend_verilog_yyerror("integer/genvar types cannot have packed dimensions.");
		}
		else {
			range_node = makeRange(type_node->range_left, type_node->range_right, false);
		}
	}

	if (range_node) {
		bool valid = true;
		if (range_node->type == AST_RANGE) {
			valid = range_node->children.size() == 2;
		} else {  // AST_MULTIRANGE
			for (auto child : range_node->children) {
				valid = valid && child->children.size() == 2;
			}
		}
		if (!valid)
			frontend_verilog_yyerror("wire/reg/logic packed dimension must be of the form [<expr>:<expr>]");
	}

	return range_node;
}

static void rewriteRange(AstNode *rangeNode)
{
	if (rangeNode->type == AST_RANGE && rangeNode->children.size() == 1) {
		// SV array size [n], rewrite as [0:n-1]
		rangeNode->children.push_back(new AstNode(AST_SUB, rangeNode->children[0], AstNode::mkconst_int(1, true)));
		rangeNode->children[0] = AstNode::mkconst_int(0, false);
	}
}

static void rewriteAsMemoryNode(AstNode *node, AstNode *rangeNode)
{
	node->type = AST_MEMORY;
	if (rangeNode->type == AST_MULTIRANGE) {
		for (auto *itr : rangeNode->children)
			rewriteRange(itr);
	} else
		rewriteRange(rangeNode);
	node->children.push_back(rangeNode);
}

static void checkLabelsMatch(const char *element, const std::string *before, const std::string *after)
{
	if (!before && after)
		frontend_verilog_yyerror("%s missing where end label (%s) was given.",
			element, after->c_str() + 1);
	if (before && after && *before != *after)
		frontend_verilog_yyerror("%s (%s) and end label (%s) don't match.",
			element, before->c_str() + 1, after->c_str() + 1);
}

// This transforms a loop like
//   for (genvar i = 0; i < 10; i++) begin : blk
// to
//   genvar _i;
//   for (_i = 0; _i < 10; _i++) begin : blk
//     localparam i = _i;
// where `_i` is actually some auto-generated name.
static void rewriteGenForDeclInit(AstNode *loop)
{
	// check if this generate for loop contains an inline declaration
	log_assert(loop->type == AST_GENFOR);
	AstNode *decl = loop->children[0];
	if (decl->type == AST_ASSIGN_EQ)
		return;
	log_assert(decl->type == AST_GENVAR);
	log_assert(loop->children.size() == 5);

	// identify each component of the loop
	AstNode *init = loop->children[1];
	AstNode *cond = loop->children[2];
	AstNode *incr = loop->children[3];
	AstNode *body = loop->children[4];
	log_assert(init->type == AST_ASSIGN_EQ);
	log_assert(incr->type == AST_ASSIGN_EQ);
	log_assert(body->type == AST_GENBLOCK);

	// create a unique name for the genvar
	std::string old_str = decl->str;
	std::string new_str = stringf("$genfordecl$%d$%s", autoidx++, old_str.c_str());

	// rename and move the genvar declaration to the containing description
	decl->str = new_str;
	loop->children.erase(loop->children.begin());
	log_assert(current_ast_mod != nullptr);
	current_ast_mod->children.push_back(decl);

	// create a new localparam with old name so that the items in the loop
	// can simply use the old name and shadow it as necessary
	AstNode *indirect = new AstNode(AST_LOCALPARAM);
	indirect->str = old_str;
	AstNode *ident = new AstNode(AST_IDENTIFIER);
	ident->str = new_str;
	indirect->children.push_back(ident);

	body->children.insert(body->children.begin(), indirect);

	// only perform the renaming for the initialization, guard, and
	// incrementation to enable proper shadowing of the synthetic localparam
	std::function<void(AstNode*)> substitute = [&](AstNode *node) {
		if (node->type == AST_IDENTIFIER && node->str == old_str)
			node->str = new_str;
		for (AstNode *child : node->children)
			substitute(child);
	};
	substitute(init);
	substitute(cond);
	substitute(incr);
}

static void ensureAsgnExprAllowed()
{
	if (!sv_mode)
		frontend_verilog_yyerror("Assignments within expressions are only supported in SystemVerilog mode.");
	if (ast_stack.back()->type != AST_BLOCK)
		frontend_verilog_yyerror("Assignments within expressions are only permitted within procedures.");
}

// add a pre/post-increment/decrement statement
static const AstNode *addIncOrDecStmt(dict<IdString, AstNode*> *stmt_attr, AstNode *lhs,
				      dict<IdString, AstNode*> *op_attr, AST::AstNodeType op,
				      YYLTYPE begin, YYLTYPE end)
{
	AstNode *one = AstNode::mkconst_int(1, true);
	AstNode *rhs = new AstNode(op, lhs->clone(), one);
	if (op_attr != nullptr)
		append_attr(rhs, op_attr);
	AstNode *stmt = new AstNode(AST_ASSIGN_EQ, lhs, rhs);
	SET_AST_NODE_LOC(stmt, begin, end);
	if (stmt_attr != nullptr)
		append_attr(stmt, stmt_attr);
	ast_stack.back()->children.push_back(stmt);
	return stmt;
}

// create a pre/post-increment/decrement expression, and add the corresponding statement
static AstNode *addIncOrDecExpr(AstNode *lhs, dict<IdString, AstNode*> *attr, AST::AstNodeType op, YYLTYPE begin, YYLTYPE end, bool undo)
{
	ensureAsgnExprAllowed();
	const AstNode *stmt = addIncOrDecStmt(nullptr, lhs, attr, op, begin, end);
	log_assert(stmt->type == AST_ASSIGN_EQ);
	AstNode *expr = stmt->children[0]->clone();
	if (undo) {
		AstNode *minus_one = AstNode::mkconst_int(-1, true, 1);
		expr = new AstNode(op, expr, minus_one);
	}
	SET_AST_NODE_LOC(expr, begin, end);
	return expr;
}

// add a binary operator assignment statement, e.g., a += b
static const AstNode *addAsgnBinopStmt(dict<IdString, AstNode*> *attr, AstNode *lhs, AST::AstNodeType op, AstNode *rhs, YYLTYPE begin, YYLTYPE end)
{
	SET_AST_NODE_LOC(rhs, end, end);
	if (op == AST_SHIFT_LEFT || op == AST_SHIFT_RIGHT ||
		op == AST_SHIFT_SLEFT || op == AST_SHIFT_SRIGHT) {
		rhs = new AstNode(AST_TO_UNSIGNED, rhs);
		SET_AST_NODE_LOC(rhs, end, end);
	}
	rhs = new AstNode(op, lhs->clone(), rhs);
	AstNode *stmt = new AstNode(AST_ASSIGN_EQ, lhs, rhs);
	SET_AST_NODE_LOC(rhs, begin, end);
	SET_AST_NODE_LOC(stmt, begin, end);
	ast_stack.back()->children.push_back(stmt);
	if (attr != nullptr)
		append_attr(stmt, attr);
	return lhs;
}


#line 403 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "verilog_parser.tab.hh".  */
#ifndef YY_FRONTEND_VERILOG_YY_FRONTENDS_VERILOG_VERILOG_PARSER_TAB_HH_INCLUDED
# define YY_FRONTEND_VERILOG_YY_FRONTENDS_VERILOG_VERILOG_PARSER_TAB_HH_INCLUDED
/* Debug traces.  */
#ifndef FRONTEND_VERILOG_YYDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define FRONTEND_VERILOG_YYDEBUG 1
#  else
#   define FRONTEND_VERILOG_YYDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define FRONTEND_VERILOG_YYDEBUG 1
# endif /* ! defined YYDEBUG */
#endif  /* ! defined FRONTEND_VERILOG_YYDEBUG */
#if FRONTEND_VERILOG_YYDEBUG
extern int frontend_verilog_yydebug;
#endif
/* "%code requires" blocks.  */
#line 373 "frontends/verilog/verilog_parser.y" /* yacc.c:355  */

#include <map>
#include <string>
#include "frontends/verilog/verilog_frontend.h"

#line 447 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:355  */

/* Token type.  */
#ifndef FRONTEND_VERILOG_YYTOKENTYPE
# define FRONTEND_VERILOG_YYTOKENTYPE
  enum frontend_verilog_yytokentype
  {
    TOK_STRING = 258,
    TOK_ID = 259,
    TOK_CONSTVAL = 260,
    TOK_REALVAL = 261,
    TOK_PRIMITIVE = 262,
    TOK_SVA_LABEL = 263,
    TOK_SPECIFY_OPER = 264,
    TOK_MSG_TASKS = 265,
    TOK_BASE = 266,
    TOK_BASED_CONSTVAL = 267,
    TOK_UNBASED_UNSIZED_CONSTVAL = 268,
    TOK_USER_TYPE = 269,
    TOK_PKG_USER_TYPE = 270,
    TOK_ASSERT = 271,
    TOK_ASSUME = 272,
    TOK_RESTRICT = 273,
    TOK_COVER = 274,
    TOK_FINAL = 275,
    ATTR_BEGIN = 276,
    ATTR_END = 277,
    DEFATTR_BEGIN = 278,
    DEFATTR_END = 279,
    TOK_MODULE = 280,
    TOK_ENDMODULE = 281,
    TOK_PARAMETER = 282,
    TOK_LOCALPARAM = 283,
    TOK_DEFPARAM = 284,
    TOK_PACKAGE = 285,
    TOK_ENDPACKAGE = 286,
    TOK_PACKAGESEP = 287,
    TOK_INTERFACE = 288,
    TOK_ENDINTERFACE = 289,
    TOK_MODPORT = 290,
    TOK_VAR = 291,
    TOK_WILDCARD_CONNECT = 292,
    TOK_INPUT = 293,
    TOK_OUTPUT = 294,
    TOK_INOUT = 295,
    TOK_WIRE = 296,
    TOK_WAND = 297,
    TOK_WOR = 298,
    TOK_REG = 299,
    TOK_LOGIC = 300,
    TOK_INTEGER = 301,
    TOK_SIGNED = 302,
    TOK_ASSIGN = 303,
    TOK_ALWAYS = 304,
    TOK_INITIAL = 305,
    TOK_ALWAYS_FF = 306,
    TOK_ALWAYS_COMB = 307,
    TOK_ALWAYS_LATCH = 308,
    TOK_BEGIN = 309,
    TOK_END = 310,
    TOK_IF = 311,
    TOK_ELSE = 312,
    TOK_FOR = 313,
    TOK_WHILE = 314,
    TOK_REPEAT = 315,
    TOK_DPI_FUNCTION = 316,
    TOK_POSEDGE = 317,
    TOK_NEGEDGE = 318,
    TOK_OR = 319,
    TOK_AUTOMATIC = 320,
    TOK_CASE = 321,
    TOK_CASEX = 322,
    TOK_CASEZ = 323,
    TOK_ENDCASE = 324,
    TOK_DEFAULT = 325,
    TOK_FUNCTION = 326,
    TOK_ENDFUNCTION = 327,
    TOK_TASK = 328,
    TOK_ENDTASK = 329,
    TOK_SPECIFY = 330,
    TOK_IGNORED_SPECIFY = 331,
    TOK_ENDSPECIFY = 332,
    TOK_SPECPARAM = 333,
    TOK_SPECIFY_AND = 334,
    TOK_IGNORED_SPECIFY_AND = 335,
    TOK_GENERATE = 336,
    TOK_ENDGENERATE = 337,
    TOK_GENVAR = 338,
    TOK_REAL = 339,
    TOK_SYNOPSYS_FULL_CASE = 340,
    TOK_SYNOPSYS_PARALLEL_CASE = 341,
    TOK_SUPPLY0 = 342,
    TOK_SUPPLY1 = 343,
    TOK_TO_SIGNED = 344,
    TOK_TO_UNSIGNED = 345,
    TOK_POS_INDEXED = 346,
    TOK_NEG_INDEXED = 347,
    TOK_PROPERTY = 348,
    TOK_ENUM = 349,
    TOK_TYPEDEF = 350,
    TOK_RAND = 351,
    TOK_CONST = 352,
    TOK_CHECKER = 353,
    TOK_ENDCHECKER = 354,
    TOK_EVENTUALLY = 355,
    TOK_INCREMENT = 356,
    TOK_DECREMENT = 357,
    TOK_UNIQUE = 358,
    TOK_UNIQUE0 = 359,
    TOK_PRIORITY = 360,
    TOK_STRUCT = 361,
    TOK_PACKED = 362,
    TOK_UNSIGNED = 363,
    TOK_INT = 364,
    TOK_BYTE = 365,
    TOK_SHORTINT = 366,
    TOK_LONGINT = 367,
    TOK_VOID = 368,
    TOK_UNION = 369,
    TOK_BIT_OR_ASSIGN = 370,
    TOK_BIT_AND_ASSIGN = 371,
    TOK_BIT_XOR_ASSIGN = 372,
    TOK_ADD_ASSIGN = 373,
    TOK_SUB_ASSIGN = 374,
    TOK_DIV_ASSIGN = 375,
    TOK_MOD_ASSIGN = 376,
    TOK_MUL_ASSIGN = 377,
    TOK_SHL_ASSIGN = 378,
    TOK_SHR_ASSIGN = 379,
    TOK_SSHL_ASSIGN = 380,
    TOK_SSHR_ASSIGN = 381,
    TOK_BIND = 382,
    TOK_TIME_SCALE = 383,
    OP_LOR = 384,
    OP_LAND = 385,
    OP_NOR = 386,
    OP_XNOR = 387,
    OP_NAND = 388,
    OP_EQ = 389,
    OP_NE = 390,
    OP_EQX = 391,
    OP_NEX = 392,
    OP_LE = 393,
    OP_GE = 394,
    OP_SHL = 395,
    OP_SHR = 396,
    OP_SSHL = 397,
    OP_SSHR = 398,
    OP_POW = 399,
    OP_CAST = 400,
    UNARY_OPS = 401,
    FAKE_THEN = 402
  };
#endif

/* Value type.  */
#if ! defined FRONTEND_VERILOG_YYSTYPE && ! defined FRONTEND_VERILOG_YYSTYPE_IS_DECLARED

union FRONTEND_VERILOG_YYSTYPE
{
#line 379 "frontends/verilog/verilog_parser.y" /* yacc.c:355  */

	std::string *string;
	struct YOSYS_NAMESPACE_PREFIX AST::AstNode *ast;
	YOSYS_NAMESPACE_PREFIX dict<YOSYS_NAMESPACE_PREFIX RTLIL::IdString, YOSYS_NAMESPACE_PREFIX AST::AstNode*> *al;
	struct specify_target *specify_target_ptr;
	struct specify_triple *specify_triple_ptr;
	struct specify_rise_fall *specify_rise_fall_ptr;
	bool boolean;
	char ch;
	int integer;
	YOSYS_NAMESPACE_PREFIX AST::AstNodeType ast_node_type;

#line 620 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:355  */
};

typedef union FRONTEND_VERILOG_YYSTYPE FRONTEND_VERILOG_YYSTYPE;
# define FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL 1
# define FRONTEND_VERILOG_YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined FRONTEND_VERILOG_YYLTYPE && ! defined FRONTEND_VERILOG_YYLTYPE_IS_DECLARED
typedef struct FRONTEND_VERILOG_YYLTYPE FRONTEND_VERILOG_YYLTYPE;
struct FRONTEND_VERILOG_YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define FRONTEND_VERILOG_YYLTYPE_IS_DECLARED 1
# define FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL 1
#endif



int frontend_verilog_yyparse (void);

#endif /* !YY_FRONTEND_VERILOG_YY_FRONTENDS_VERILOG_VERILOG_PARSER_TAB_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 650 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL \
             && defined FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3632

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  174
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  309
/* YYNRULES -- Number of rules.  */
#define YYNRULES  702
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1363

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   402

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   173,     2,   164,     2,   153,   135,     2,
     161,   162,   151,   149,   158,   150,   160,   152,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   165,   163,
     141,   159,   144,   171,   170,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   166,     2,   167,   133,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   168,   131,   169,   172,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   132,   134,   136,   137,
     138,   139,   140,   142,   143,   145,   146,   147,   148,   154,
     155,   156,   157
};

#if FRONTEND_VERILOG_YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   466,   466,   466,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   490,   490,   506,   509,   512,   519,
     512,   530,   530,   533,   534,   537,   543,   551,   554,   562,
     572,   573,   574,   578,   580,   578,   605,   605,   605,   605,
     608,   608,   611,   612,   612,   618,   618,   624,   627,   627,
     627,   630,   630,   633,   633,   636,   654,   657,   657,   671,
     676,   671,   686,   686,   702,   707,   709,   707,   726,   726,
     729,   729,   729,   729,   732,   734,   732,   755,   755,   758,
     758,   758,   758,   758,   758,   758,   759,   759,   762,   767,
     771,   762,   799,   804,   805,   808,   809,   814,   822,   823,
     826,   827,   828,   830,   831,   832,   833,   834,   837,   837,
     840,   840,   845,   845,   850,   851,   854,   857,   860,   866,
     867,   868,   871,   875,   878,   881,   884,   884,   888,   890,
     893,   896,   900,   903,   906,   909,   918,   921,   924,   927,
     929,   934,   939,   940,   941,   942,   943,   946,   947,   950,
     955,   961,   967,   973,   976,   982,   985,   990,   991,   994,
     996,   997,   998,   999,  1002,  1002,  1002,  1002,  1002,  1002,
    1002,  1002,  1002,  1002,  1003,  1003,  1003,  1004,  1004,  1004,
    1004,  1004,  1004,  1007,  1007,  1018,  1018,  1028,  1028,  1039,
    1039,  1051,  1051,  1063,  1063,  1080,  1080,  1105,  1110,  1113,
    1117,  1122,  1123,  1124,  1128,  1129,  1130,  1133,  1134,  1135,
    1139,  1144,  1150,  1151,  1154,  1155,  1156,  1157,  1160,  1161,
    1164,  1164,  1164,  1168,  1164,  1176,  1176,  1179,  1179,  1200,
    1200,  1214,  1215,  1220,  1223,  1224,  1227,  1311,  1385,  1388,
    1393,  1396,  1401,  1404,  1409,  1415,  1421,  1427,  1435,  1436,
    1437,  1440,  1448,  1455,  1464,  1476,  1496,  1502,  1512,  1513,
    1516,  1517,  1520,  1523,  1524,  1528,  1529,  1535,  1538,  1538,
    1541,  1544,  1544,  1547,  1553,  1554,  1558,  1559,  1560,  1564,
    1565,  1569,  1569,  1572,  1573,  1574,  1577,  1578,  1579,  1583,
    1584,  1587,  1588,  1591,  1592,  1595,  1595,  1595,  1599,  1603,
    1606,  1609,  1610,  1611,  1614,  1615,  1616,  1623,  1626,  1627,
    1634,  1634,  1640,  1642,  1644,  1647,  1652,  1657,  1663,  1665,
    1668,  1671,  1674,  1674,  1674,  1674,  1675,  1680,  1680,  1689,
    1689,  1698,  1698,  1701,  1707,  1720,  1737,  1740,  1740,  1743,
    1756,  1756,  1779,  1780,  1781,  1785,  1791,  1792,  1796,  1797,
    1798,  1801,  1802,  1806,  1821,  1822,  1826,  1827,  1830,  1842,
    1850,  1850,  1857,  1857,  1861,  1862,  1865,  1869,  1870,  1873,
    1874,  1875,  1878,  1879,  1882,  1886,  1887,  1890,  1890,  1899,
    1899,  1903,  1908,  1910,  1908,  1922,  1923,  1924,  1927,  1928,
    1931,  1944,  1948,  1944,  1954,  1954,  1962,  1962,  1972,  1973,
    1984,  1984,  1987,  2029,  2057,  2103,  2106,  2106,  2109,  2115,
    2116,  2120,  2133,  2137,  2142,  2151,  2160,  2161,  2165,  2165,
    2174,  2174,  2184,  2187,  2192,  2193,  2196,  2196,  2199,  2199,
    2210,  2210,  2221,  2222,  2225,  2226,  2229,  2230,  2230,  2238,
    2238,  2241,  2241,  2244,  2245,  2250,  2253,  2262,  2289,  2289,
    2292,  2297,  2303,  2311,  2318,  2327,  2335,  2338,  2343,  2346,
    2351,  2358,  2351,  2371,  2371,  2387,  2387,  2401,  2402,  2403,
    2404,  2405,  2406,  2409,  2410,  2411,  2414,  2420,  2426,  2433,
    2436,  2441,  2444,  2449,  2452,  2455,  2460,  2466,  2460,  2472,
    2472,  2475,  2475,  2478,  2479,  2482,  2492,  2492,  2495,  2508,
    2521,  2534,  2547,  2556,  2565,  2574,  2589,  2606,  2615,  2624,
    2633,  2642,  2651,  2664,  2679,  2685,  2688,  2691,  2697,  2702,
    2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,
    2713,  2718,  2719,  2722,  2730,  2733,  2771,  2771,  2771,  2771,
    2771,  2771,  2772,  2773,  2774,  2777,  2777,  2788,  2788,  2799,
    2801,  2799,  2826,  2831,  2833,  2826,  2844,  2844,  2858,  2858,
    2872,  2883,  2872,  2890,  2890,  2903,  2906,  2910,  2914,  2921,
    2924,  2927,  2932,  2936,  2940,  2943,  2944,  2947,  2947,  2958,
    2961,  2962,  2965,  2971,  2965,  2984,  2985,  2988,  2994,  2988,
    3003,  3004,  3007,  3012,  3019,  3022,  3027,  3033,  3043,  3051,
    3054,  3059,  3063,  3069,  3070,  3073,  3074,  3077,  3078,  3081,
    3086,  3087,  3088,  3091,  3091,  3092,  3097,  3104,  3107,  3123,
    3131,  3135,  3131,  3142,  3142,  3151,  3151,  3160,  3160,  3172,
    3174,  3172,  3190,  3190,  3197,  3200,  3200,  3203,  3206,  3214,
    3219,  3224,  3227,  3237,  3251,  3258,  3270,  3275,  3275,  3286,
    3290,  3294,  3297,  3302,  3305,  3308,  3313,  3318,  3323,  3328,
    3333,  3338,  3343,  3348,  3354,  3359,  3366,  3371,  3376,  3381,
    3386,  3391,  3396,  3401,  3406,  3411,  3416,  3421,  3426,  3431,
    3436,  3441,  3446,  3451,  3456,  3461,  3466,  3471,  3476,  3481,
    3486,  3491,  3497,  3503,  3509,  3515,  3522,  3528,  3531,  3537,
    3538,  3539,  3544
};
#endif

#if FRONTEND_VERILOG_YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_STRING", "TOK_ID", "TOK_CONSTVAL",
  "TOK_REALVAL", "TOK_PRIMITIVE", "TOK_SVA_LABEL", "TOK_SPECIFY_OPER",
  "TOK_MSG_TASKS", "TOK_BASE", "TOK_BASED_CONSTVAL",
  "TOK_UNBASED_UNSIZED_CONSTVAL", "TOK_USER_TYPE", "TOK_PKG_USER_TYPE",
  "TOK_ASSERT", "TOK_ASSUME", "TOK_RESTRICT", "TOK_COVER", "TOK_FINAL",
  "ATTR_BEGIN", "ATTR_END", "DEFATTR_BEGIN", "DEFATTR_END", "TOK_MODULE",
  "TOK_ENDMODULE", "TOK_PARAMETER", "TOK_LOCALPARAM", "TOK_DEFPARAM",
  "TOK_PACKAGE", "TOK_ENDPACKAGE", "TOK_PACKAGESEP", "TOK_INTERFACE",
  "TOK_ENDINTERFACE", "TOK_MODPORT", "TOK_VAR", "TOK_WILDCARD_CONNECT",
  "TOK_INPUT", "TOK_OUTPUT", "TOK_INOUT", "TOK_WIRE", "TOK_WAND",
  "TOK_WOR", "TOK_REG", "TOK_LOGIC", "TOK_INTEGER", "TOK_SIGNED",
  "TOK_ASSIGN", "TOK_ALWAYS", "TOK_INITIAL", "TOK_ALWAYS_FF",
  "TOK_ALWAYS_COMB", "TOK_ALWAYS_LATCH", "TOK_BEGIN", "TOK_END", "TOK_IF",
  "TOK_ELSE", "TOK_FOR", "TOK_WHILE", "TOK_REPEAT", "TOK_DPI_FUNCTION",
  "TOK_POSEDGE", "TOK_NEGEDGE", "TOK_OR", "TOK_AUTOMATIC", "TOK_CASE",
  "TOK_CASEX", "TOK_CASEZ", "TOK_ENDCASE", "TOK_DEFAULT", "TOK_FUNCTION",
  "TOK_ENDFUNCTION", "TOK_TASK", "TOK_ENDTASK", "TOK_SPECIFY",
  "TOK_IGNORED_SPECIFY", "TOK_ENDSPECIFY", "TOK_SPECPARAM",
  "TOK_SPECIFY_AND", "TOK_IGNORED_SPECIFY_AND", "TOK_GENERATE",
  "TOK_ENDGENERATE", "TOK_GENVAR", "TOK_REAL", "TOK_SYNOPSYS_FULL_CASE",
  "TOK_SYNOPSYS_PARALLEL_CASE", "TOK_SUPPLY0", "TOK_SUPPLY1",
  "TOK_TO_SIGNED", "TOK_TO_UNSIGNED", "TOK_POS_INDEXED", "TOK_NEG_INDEXED",
  "TOK_PROPERTY", "TOK_ENUM", "TOK_TYPEDEF", "TOK_RAND", "TOK_CONST",
  "TOK_CHECKER", "TOK_ENDCHECKER", "TOK_EVENTUALLY", "TOK_INCREMENT",
  "TOK_DECREMENT", "TOK_UNIQUE", "TOK_UNIQUE0", "TOK_PRIORITY",
  "TOK_STRUCT", "TOK_PACKED", "TOK_UNSIGNED", "TOK_INT", "TOK_BYTE",
  "TOK_SHORTINT", "TOK_LONGINT", "TOK_VOID", "TOK_UNION",
  "TOK_BIT_OR_ASSIGN", "TOK_BIT_AND_ASSIGN", "TOK_BIT_XOR_ASSIGN",
  "TOK_ADD_ASSIGN", "TOK_SUB_ASSIGN", "TOK_DIV_ASSIGN", "TOK_MOD_ASSIGN",
  "TOK_MUL_ASSIGN", "TOK_SHL_ASSIGN", "TOK_SHR_ASSIGN", "TOK_SSHL_ASSIGN",
  "TOK_SSHR_ASSIGN", "TOK_BIND", "TOK_TIME_SCALE", "OP_LOR", "OP_LAND",
  "'|'", "OP_NOR", "'^'", "OP_XNOR", "'&'", "OP_NAND", "OP_EQ", "OP_NE",
  "OP_EQX", "OP_NEX", "'<'", "OP_LE", "OP_GE", "'>'", "OP_SHL", "OP_SHR",
  "OP_SSHL", "OP_SSHR", "'+'", "'-'", "'*'", "'/'", "'%'", "OP_POW",
  "OP_CAST", "UNARY_OPS", "FAKE_THEN", "','", "'='", "'.'", "'('", "')'",
  "';'", "'#'", "':'", "'['", "']'", "'{'", "'}'", "'@'", "'?'", "'~'",
  "'!'", "$accept", "input", "$@1", "design", "attr", "$@2", "attr_opt",
  "defattr", "$@3", "$@4", "opt_attr_list", "attr_list", "attr_assign",
  "hierarchical_id", "hierarchical_type_id", "module", "$@5", "$@6",
  "module_para_opt", "$@7", "$@8", "module_para_list",
  "single_module_para", "$@9", "$@10", "module_args_opt", "module_args",
  "optional_comma", "module_arg_opt_assignment", "module_arg", "$@11",
  "$@12", "$@13", "$@14", "package", "$@15", "$@16", "package_body",
  "package_body_stmt", "interface", "$@17", "$@18", "interface_body",
  "interface_body_stmt", "bind_directive", "$@19", "$@20", "$@21",
  "bind_target", "opt_bind_target_instance_list",
  "bind_target_instance_list", "bind_target_instance", "mintypmax_expr",
  "non_opt_delay", "delay", "io_wire_type", "$@22", "non_io_wire_type",
  "$@23", "wire_type", "wire_type_token_io", "wire_type_signedness",
  "wire_type_const_rand", "opt_wire_type_token", "wire_type_token",
  "net_type", "logic_type", "integer_atom_type", "integer_vector_type",
  "non_opt_range", "non_opt_multirange", "range", "range_or_multirange",
  "module_body", "module_body_stmt", "checker_decl", "$@24",
  "task_func_decl", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "func_return_type", "opt_type_vec", "opt_signedness_default_signed",
  "opt_signedness_default_unsigned", "dpi_function_arg",
  "opt_dpi_function_args", "dpi_function_args", "opt_automatic",
  "task_func_args_opt", "$@31", "$@32", "task_func_args", "task_func_port",
  "$@33", "$@34", "task_func_body", "specify_block", "specify_item_list",
  "specify_item", "specify_opt_triple", "specify_if", "specify_condition",
  "specify_target", "specify_edge", "specify_rise_fall", "specify_triple",
  "ignored_specify_block", "ignored_specify_item_opt",
  "ignored_specify_item", "specparam_declaration", "specparam_range",
  "list_of_specparam_assignments", "specparam_assignment",
  "ignspec_opt_cond", "path_declaration", "simple_path_declaration",
  "path_delay_value", "list_of_path_delay_extra_expressions",
  "specify_edge_identifier", "parallel_path_description",
  "full_path_description", "list_of_path_inputs", "more_path_inputs",
  "list_of_path_outputs", "opt_polarity_operator",
  "specify_input_terminal_descriptor",
  "specify_output_terminal_descriptor", "system_timing_declaration",
  "system_timing_arg", "system_timing_args", "ignspec_constant_expression",
  "ignspec_expr", "ignspec_id", "$@35", "param_signed", "param_integer",
  "param_real", "param_range", "param_integer_type", "param_range_type",
  "param_implicit_type", "param_type", "param_decl", "$@36",
  "localparam_decl", "$@37", "param_decl_list", "single_param_decl",
  "single_param_decl_ident", "defparam_decl", "defparam_decl_list",
  "single_defparam_decl", "enum_type", "$@38", "enum_base_type",
  "type_atom", "type_vec", "type_signing", "enum_name_list",
  "enum_name_decl", "opt_enum_init", "enum_var_list", "enum_var",
  "enum_decl", "struct_decl", "$@39", "struct_type", "$@40",
  "struct_union", "struct_body", "opt_packed", "opt_signed_struct",
  "struct_member_list", "struct_member", "member_name_list", "member_name",
  "$@41", "struct_member_type", "$@42", "member_type_token", "$@43",
  "$@44", "member_type", "struct_var_list", "struct_var", "wire_decl",
  "$@45", "$@46", "$@47", "$@48", "opt_supply_wires", "wire_name_list",
  "wire_name_and_opt_assign", "wire_name", "assign_stmt",
  "assign_expr_list", "assign_expr", "type_name", "typedef_decl",
  "typedef_base_type", "enum_struct_type", "cell_stmt", "$@49", "$@50",
  "tok_prim_wrapper", "cell_list", "single_cell", "single_cell_no_array",
  "$@51", "single_cell_arraylist", "$@52", "cell_list_no_array",
  "prim_list", "single_prim", "$@53", "cell_parameter_list_opt",
  "cell_parameter_list", "cell_parameter", "cell_port_list",
  "cell_port_list_rules", "cell_port", "always_comb_or_latch",
  "always_or_always_ff", "always_stmt", "$@54", "$@55", "$@56", "$@57",
  "always_cond", "always_events", "always_event", "opt_label",
  "opt_sva_label", "opt_property", "modport_stmt", "$@58", "$@59",
  "modport_args_opt", "modport_args", "modport_arg", "modport_member",
  "modport_type_token", "assert", "assert_property",
  "simple_behavioral_stmt", "asgn_binop", "inc_or_dec_op",
  "for_initialization", "behavioral_stmt", "$@60", "$@61", "$@62", "$@63",
  "$@64", "$@65", "$@66", "$@67", "$@68", "$@69", "$@70", "$@71",
  "case_attr", "case_type", "opt_synopsys_attr", "behavioral_stmt_list",
  "optional_else", "$@72", "case_body", "case_item", "$@73", "$@74",
  "gen_case_body", "gen_case_item", "$@75", "$@76", "case_select",
  "case_expr_list", "rvalue", "lvalue", "lvalue_concat_list",
  "opt_arg_list", "arg_list", "arg_list2", "single_arg", "module_gen_body",
  "gen_stmt_or_module_body_stmt", "genvar_identifier",
  "genvar_initialization", "gen_stmt", "$@77", "$@78", "$@79", "$@80",
  "$@81", "gen_block", "$@82", "$@83", "gen_stmt_block", "$@84",
  "opt_gen_else", "expr", "basic_expr", "$@85", "concat_list",
  "integral_number", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   124,   386,    94,   387,    38,   388,   389,   390,   391,
     392,    60,   393,   394,    62,   395,   396,   397,   398,    43,
      45,    42,    47,    37,   399,   400,   401,   402,    44,    61,
      46,    40,    41,    59,    35,    58,    91,    93,   123,   125,
      64,    63,   126,    33
};
# endif

#define YYPACT_NINF -1099

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1099)))

#define YYTABLE_NINF -593

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1099,    76,   421, -1099, -1099, -1099,   753, -1099, -1099,   856,
   -1099,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     131,   183, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099,   167, -1099,    28,   101, -1099, -1099,
   -1099,    44,   107,   131, -1099, -1099, -1099, -1099,   203,   159,
     159,   217, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099,    91, -1099,   255, -1099,   681,    84, -1099,
   -1099, -1099, -1099, -1099, -1099,   237,  2558,    44,    44, -1099,
     107, -1099, -1099,   197,    63, -1099,   263,   380,   694,   694,
     449,    88, -1099,   602,   475,   131,   396,   131,   502,  2558,
     520,   395, -1099, -1099, -1099,   273,   233,   233, -1099,   277,
   -1099,   376, -1099,   541, -1099,   556, -1099,   438, -1099, -1099,
   -1099, -1099,   477, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099,  2631,  2558, -1099, -1099,   337,   487, -1099,   348,    64,
    3320, -1099, -1099, -1099,    44, -1099,   626,   131, -1099, -1099,
   -1099, -1099, -1099, -1099,    44,   305, -1099, -1099, -1099, -1099,
     640, -1099,   305,   640, -1099, -1099,   645,   647, -1099, -1099,
     655, -1099,    28,   657,   101, -1099,   641, -1099, -1099, -1099,
   -1099, -1099,   505,   507,   695, -1099, -1099, -1099,    44, -1099,
   -1099, -1099, -1099,   609, -1099,   540,   542,   555,   567,  2915,
    2915,  2915,  2915,  2915,  2915,  2915,  2915,    84,  1709,   -40,
     564,  2915,  2915,  2558, -1099,    44, -1099, -1099,   576,   131,
   -1099,  2558,  2558,  2558, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099,   594, -1099,   610, -1099,   618, -1099,   395, -1099, -1099,
   -1099, -1099, -1099,   205, -1099,   616,    44,   280,   619,   620,
     781,   630, -1099, -1099, -1099,    44,   633, -1099, -1099,   116,
     637,   649,   638, -1099, -1099,   650, -1099,   805,   715, -1099,
    2558,  2558,  2558,  2558, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099,  2558,   494,  2558,  2558,  2558,
    2558, -1099, -1099, -1099,   355,   659,  2558,    42, -1099,   651,
     663,   666,  2915,  2915,  2915,  2915,  2915,  2915,  2915,  2915,
    2915,  2915,  2915,  2915,  2915,  2915,  2915,  2915,  2915,  2915,
    2915,  2915,  2915,  2915,  2915,  2915,  2915,  2915,  2558,  2558,
   -1099,   658,   131,   507,   640, -1099,  2558, -1099, -1099, -1099,
     825,   673, -1099,   838,   633,   633, -1099,   682,   683,   119,
     841,   688, -1099,   617,   691, -1099, -1099,  2915, -1099,   695,
     684, -1099, -1099, -1099,   312, -1099, -1099,   233,   233, -1099,
      26,    44,   690,   692,   696,   699,   704, -1099,   685,   706,
     698, -1099,   700,   697,  2558,   710, -1099, -1099, -1099,  3389,
    3414,  3437,  3437,  3458,  3458,  3477,  3477,  3335,  3335,  3335,
    3335,  1026,  1026,  1026,  1026,   662,   662,   662,   662,   483,
     483,   309,   309,   309,   718,   712,   713,   719,   875, -1099,
     722, -1099, -1099,    78,   878, -1099,   -45, -1099,   620,   886,
     729,   730, -1099,   892, -1099,   490,   739, -1099, -1099,   740,
     894,   741, -1099,   636, -1099,   488,    44,   126,   738,   291,
    3363, -1099, -1099,    44,   805, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099,  2558, -1099,   733,   131,   745,
   -1099, -1099, -1099, -1099, -1099,  2558,  1705, -1099, -1099,   374,
   -1099,   746,   529, -1099, -1099, -1099, -1099, -1099, -1099,   825,
   -1099,   742, -1099, -1099, -1099,   617,   752, -1099,   900,   357,
   -1099, -1099,   119,   754,  2558, -1099, -1099, -1099, -1099, -1099,
   -1099,   488,   818, -1099,  1234,   915, -1099, -1099,    44, -1099,
     916,   757,  1361, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099,   237,   760, -1099, -1099,  2558,
     769, -1099,   928,   219, -1099, -1099,   772,   875, -1099,  3095,
     930, -1099, -1099, -1099,   620,   416,   546,    44,   102, -1099,
      44, -1099,   770, -1099,   200,   885, -1099,   679, -1099, -1099,
   -1099, -1099,   674, -1099,   773, -1099,   686,   694,   694, -1099,
   -1099, -1099,   740,  1234, -1099,   978, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099,   319,  1226, -1099, -1099, -1099,   131,   384,
   -1099, -1099, -1099,    53, -1099, -1099, -1099, -1099, -1099,   933,
     934,    44, -1099, -1099, -1099, -1099, -1099, -1099,   779,  1705,
   -1099, -1099, -1099, -1099,   746, -1099,   788,   789, -1099, -1099,
   -1099,   118,   519,    67, -1099,   938, -1099,  3325, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,   951,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099,   702, -1099,   795,
   -1099, -1099, -1099,   794, -1099, -1099, -1099, -1099,   796, -1099,
   -1099, -1099, -1099, -1099, -1099,  1774, -1099, -1099,   800,   801,
     802,   803, -1099, -1099, -1099, -1099,  2558,   311, -1099, -1099,
    1304, -1099,    90,    90,    90,   177, -1099,   806,   640,   640,
   -1099,   319, -1099, -1099, -1099, -1099, -1099, -1099, -1099,   740,
     807,    44, -1099,   808,   388, -1099,   809,   679, -1099, -1099,
   -1099,   679,   812,  1847, -1099,  1155,   813,   819, -1099,   810,
   -1099,   746,  2558, -1099,   815,   817,   893,   118,   823, -1099,
     824, -1099,   545, -1099, -1099,   830, -1099,   816, -1099,   833,
    2558,   991,   397, -1099,   840,  3129,   834, -1099, -1099, -1099,
   -1099,   757, -1099,   403, -1099,   908,   909,   910,   912,  2558,
   -1099,   900, -1099,   845,   318,   843,   810,   746,  2558, -1099,
    2558,  2558,   844,   857,   810,    53,   757,   757,   348,   757,
   -1099, -1099,   855,   865,   866, -1099,   868,  2558, -1099, -1099,
   -1099, -1099,  2558, -1099,   111, -1099,    53, -1099,  2558, -1099,
   -1099, -1099,   757, -1099,    75, -1099, -1099,   873, -1099,  1013,
   -1099, -1099, -1099,  2558,   867, -1099,   874,    68,   608,  2558,
   -1099, -1099,   608,    44,  2558, -1099, -1099,   360,   879,   880,
   -1099,  1451,   872, -1099,   413,   991, -1099,  2558, -1099,  3028,
   -1099, -1099, -1099, -1099, -1099,   658,  1036, -1099,   951, -1099,
     882,   883,   888,   890,   884, -1099, -1099,  2558, -1099,  2558,
     889, -1099,   899,  1037,   901,   902, -1099,  2558,   891, -1099,
    2558,  2558, -1099,  2558,  1916,  2026,  2095,  2168,   903, -1099,
   -1099, -1099, -1099, -1099,   897, -1099, -1099,  1062,   904, -1099,
   -1099,   420,   428,   900,   911, -1099,  1371,   679, -1099,   913,
   -1099,   745, -1099, -1099, -1099, -1099,  1067,   917,   918, -1099,
   -1099,  2558,   920,  2558, -1099,   922,   907, -1099, -1099,   991,
     924,   336, -1099,  2700,  2700,   991,   991, -1099,   209, -1099,
    2558, -1099, -1099, -1099, -1099, -1099,  1082, -1099,   445, -1099,
    1082, -1099,  2237,  2347,  2416,  2558, -1099,   412,   926, -1099,
   -1099, -1099,   935,    44,   929, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099,  2558,   931,  2558,   937,  2558,   940,   932,   941,
   -1099,   422,   942, -1099, -1099,  1101, -1099, -1099,   948, -1099,
     949, -1099, -1099,  2558,  2558,   947,   221, -1099, -1099, -1099,
    2489,   950,  3218,  1056,   952,  2558,  2558,  1035, -1099,  1106,
   -1099,  2558,   966,   307,   976, -1099, -1099,   991,   381,   962,
    2631, -1099,   964, -1099, -1099, -1099,  1451,  1451,   961,   960,
    1002,    44,   448, -1099, -1099, -1099,  1036, -1099, -1099,   456,
   -1099,   967,  2558,   968,  2558,   969,  2558,   970,   971, -1099,
    2558, -1099,  2558,   517,   679,  2558,  1130,  2558,   679,   679,
     973,   974,   979,   975,   981,   982, -1099,   984, -1099, -1099,
   -1099, -1099,   900,   985,  2558, -1099, -1099, -1099,  1563,  1563,
   -1099, -1099,   987, -1099,   746, -1099,  1079,  3252,  2558, -1099,
   -1099,  2558,   992,  2773,   986,  1008,  1009, -1099,   991, -1099,
     991, -1099,  1011,   964,  2493,  2558, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099,  1082, -1099, -1099,  1082, -1099, -1099,   994,
     999,   995,  1000,  1005,  1021,  1022,  1120,  1028, -1099,   746,
   -1099, -1099, -1099,  1032, -1099, -1099, -1099,  1030, -1099,  1033,
   -1099,  1041, -1099, -1099,   599, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099,  1056, -1099, -1099, -1099,  1042, -1099,   608,  2631,
    1044, -1099,  2558,  1034,  1047,   437, -1099, -1099, -1099,   991,
    1048,  2558,   964,  1051, -1099, -1099,  1061,  1046, -1099,  1063,
   -1099,  1066, -1099, -1099, -1099, -1099,  1632, -1099, -1099,  1141,
    2558,  1068, -1099, -1099, -1099, -1099, -1099,  1156, -1099, -1099,
    2558,  1567,  1065, -1099,   991,   991,   991, -1099,  1071, -1099,
    1070, -1099, -1099, -1099, -1099, -1099, -1099, -1099,   169, -1099,
     171, -1099, -1099, -1099, -1099, -1099, -1099, -1099,  1632,    69,
    1074,  1035,  2558,  2558,  2558,  2842,   334,   346, -1099, -1099,
    2558,  1075,  1056,  2558, -1099,   679,  1076, -1099,  1056,  1084,
    1081,  1085,    -3,  2631,  1083, -1099,  1087,  2558,  1088,  2558,
    1089,   760, -1099, -1099, -1099, -1099, -1099,   679, -1099,  2558,
   -1099, -1099, -1099,  1097,  2635, -1099,  2558,  1096,  2558,  1098,
    2558,   679, -1099,  1103,  2558,  2558,  1104,  1100,  1111,  1112,
    1119, -1099,  2558,  1121,   466,  1117,  2558, -1099,  1122, -1099,
    1123, -1099,  1105,  2558, -1099,  2558, -1099, -1099, -1099, -1099,
     469,   760,  2558, -1099,  1134,  2558,  1135,  2558,   481,  2558,
   -1099,  1136,  2558,  1138,  2558,  1139,  2558,  1140,  2558,  1142,
    2558,  1137, -1099
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,    14,     1,    18,    74,     0,    88,     3,     0,
      17,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      22,     0,    30,    31,   148,   147,   142,   340,   364,   143,
     146,   144,   145,   365,     0,   413,   204,   207,   416,   417,
     362,   156,     0,     0,    33,   327,   329,    65,     0,   219,
     219,    15,     5,     4,    10,    11,    12,     6,     7,     8,
       9,    27,    19,    21,    23,    25,    75,   344,     0,   205,
     206,   415,   208,   209,   414,   368,     0,   155,   158,   157,
       0,   409,   410,     0,    97,    89,    94,     0,   314,   314,
       0,     0,   218,   201,     0,    22,     0,     0,     0,     0,
       0,    39,   346,   347,   345,     0,   350,   350,    32,   371,
     363,     0,   646,   699,   645,     0,   700,     0,    14,    14,
     531,   532,     0,    14,    14,    14,    14,    14,    14,    14,
      14,     0,     0,    14,    14,   156,     0,    14,   641,     0,
     637,   644,   153,   154,   156,   412,     0,     0,    92,    34,
     312,   316,   313,   326,   156,   314,   323,   322,   324,   325,
       0,   315,   314,     0,    66,   185,     0,     0,   202,   203,
       0,   197,   204,     0,   207,   191,     0,    20,    24,    28,
      26,    29,     0,    49,     0,   348,   349,   342,   156,   369,
     370,   367,   379,     0,   701,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,     0,   697,
       0,     0,     0,     0,   647,   598,   597,   643,     0,     0,
     640,     0,     0,     0,   152,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,     0,    14,     0,    90,    93,    95,    39,   155,   317,
     321,   318,   335,     0,   331,   334,   319,     0,     0,   213,
       0,     0,   193,   200,   195,   198,   221,    16,    36,    14,
       0,   355,    54,   351,   343,   379,   372,     0,   382,   702,
       0,     0,     0,     0,   641,   664,   665,   666,   667,   662,
     663,   686,   687,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,     0,   651,     0,     0,     0,
       0,   653,   655,   690,     0,     0,     0,   156,   639,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     411,   440,     0,    49,     0,   328,     0,   320,   330,    69,
     217,     0,   187,     0,   221,   221,   199,   222,     0,    14,
      57,     0,    48,   112,    54,    51,    78,     0,   353,    53,
       0,   366,   373,   377,     0,   375,   387,   350,   350,   380,
       0,   156,     0,     0,     0,     0,     0,   642,     0,     0,
     697,   698,     0,   152,   606,     0,   150,   151,   149,   689,
     688,   658,   659,   660,   661,   656,   657,   674,   675,   676,
     677,   672,   673,   678,   679,   668,   669,   670,   671,   680,
     681,   682,   683,   684,   685,     0,     0,     0,     0,    96,
       0,   332,   333,    14,   211,   216,     0,   186,   213,     0,
       0,     0,   220,    14,   232,     0,    37,    40,    47,    56,
       0,     0,   114,     0,   115,   125,   156,    14,     0,    14,
     354,   352,   341,   156,     0,   374,   385,   386,   383,   381,
     691,   649,   650,   692,   695,     0,   696,     0,     0,    54,
     605,   607,   609,   694,   693,     0,   443,   428,   432,     0,
     163,   480,     0,    68,    73,    72,    71,    70,   210,   215,
     212,     0,   189,   232,   232,   112,    54,   225,     0,    14,
      43,    45,    14,     0,     0,    58,    60,    64,   116,   117,
     118,   125,   124,   123,     0,     0,    52,    50,   156,    76,
       0,   109,   112,    77,    87,    79,    80,    82,    83,    85,
      81,    84,    86,   378,   376,   368,     0,   654,   596,    53,
       0,   638,     0,     0,   441,   444,     0,     0,    91,    14,
       0,    67,   214,   188,   213,    14,    14,   156,    14,   223,
     156,   230,     0,   192,     0,   112,   536,    14,   539,   540,
     538,   541,     0,   537,     0,   231,     0,   314,   314,    41,
      38,    55,    56,   127,   122,   132,   138,   137,   136,   130,
     139,   135,   141,   121,   128,   134,   140,    62,     0,     0,
     337,   486,   108,     0,   458,   465,   459,   456,   457,     0,
       0,   156,   463,   460,   384,   652,   608,   648,     0,   443,
     439,    14,   433,   627,   480,   629,     0,     0,   569,   570,
     571,   235,   272,     0,   612,     0,   162,   112,   179,   176,
     159,   181,   164,   165,   182,   170,   166,   167,   169,     0,
     174,   175,   171,   172,   168,   173,   177,     0,   180,     0,
     160,   161,   479,     0,   194,   196,   227,   226,     0,   404,
     481,   100,   101,   102,   103,     0,   547,   549,     0,     0,
       0,     0,   568,   566,   567,   544,     0,   156,    14,   599,
      14,   542,   485,   485,   485,   485,   543,     0,     0,     0,
      61,   121,   126,   131,   133,   119,   120,   113,   129,    56,
       0,   156,   336,     0,     0,   406,     0,    14,   394,   396,
     391,    14,   472,     0,   442,   450,     0,   447,   448,   604,
      35,   480,     0,   620,     0,     0,     0,   235,     0,   310,
       0,   259,   272,   261,   262,     0,   263,     0,   264,     0,
       0,     0,     0,   268,     0,    14,     0,   418,   422,   423,
     360,   109,   358,     0,   356,     0,     0,     0,     0,     0,
     190,     0,   224,     0,     0,    98,   604,   480,     0,   552,
       0,     0,     0,   601,   604,     0,   109,   109,     0,   109,
     484,   483,     0,     0,     0,   504,     0,     0,    44,    46,
     111,    63,     0,   338,     0,   487,     0,   405,     0,   466,
     398,   398,   109,   464,     0,   461,   445,     0,   455,     0,
     451,   429,    14,   606,     0,   630,     0,     0,   250,     0,
     233,   234,   250,   156,     0,   258,   260,     0,     0,     0,
     273,     0,     0,   307,     0,     0,   265,     0,   178,   112,
     614,   610,   613,   611,   183,   440,     0,   420,     0,   359,
       0,     0,     0,     0,     0,   228,   104,     0,   105,     0,
       0,   550,     0,   112,     0,     0,   600,     0,     0,   516,
       0,     0,   515,     0,     0,     0,     0,     0,     0,   339,
     495,   496,   497,   489,    54,   491,   494,     0,     0,   407,
     408,     0,     0,     0,     0,   471,     0,    14,   446,   454,
     449,    54,   628,   612,   623,   616,     0,     0,     0,   248,
     249,     0,     0,     0,   311,     0,   308,   281,   282,     0,
       0,   297,   298,     0,     0,     0,     0,   304,     0,   303,
       0,   266,   269,   270,   615,   163,     0,   390,     0,   388,
     437,   357,     0,     0,     0,     0,   625,     0,     0,   548,
     576,   560,     0,   156,     0,   556,   558,   602,   546,   517,
     514,   518,     0,     0,     0,     0,     0,     0,     0,     0,
     563,    53,     0,   493,   488,     0,   395,   397,   392,   400,
     402,   469,   470,     0,     0,     0,     0,   473,   478,   462,
       0,     0,    14,   632,   617,     0,     0,   243,   240,     0,
     271,     0,     0,   297,     0,   295,   296,     0,   297,   289,
       0,   274,   277,   275,   301,   302,     0,     0,     0,     0,
      14,   428,     0,   424,   426,   427,     0,   361,   436,     0,
     434,     0,     0,     0,     0,     0,     0,     0,     0,   586,
       0,   106,     0,    14,    14,     0,     0,     0,    14,    14,
       0,     0,     0,     0,     0,     0,   503,     0,   574,   492,
     490,   399,     0,     0,     0,   476,   477,   468,     0,     0,
     467,   453,     0,   603,   480,   634,   636,    14,     0,   619,
     621,     0,     0,     0,     0,     0,     0,   289,     0,   291,
       0,   290,     0,     0,   308,     0,   278,   305,   306,   300,
     267,   184,   430,     0,   419,   389,   437,   421,    14,     0,
       0,     0,     0,     0,     0,     0,   587,     0,    99,   480,
     575,   561,   533,   534,   553,   557,   559,     0,   498,     0,
     499,     0,   505,   502,   581,   401,   393,   403,   474,   475,
     452,   631,   632,   624,   633,   618,     0,   242,   250,     0,
       0,   244,     0,     0,     0,     0,   293,   299,   292,     0,
       0,     0,   279,     0,   425,   435,     0,     0,   507,     0,
     508,     0,   512,   511,   626,   585,     0,   107,   551,   579,
       0,     0,   500,   501,   506,   572,   573,   582,   635,    14,
       0,     0,     0,   309,     0,     0,     0,   286,     0,   276,
       0,   280,    14,   438,   509,   510,   513,   593,   591,   588,
       0,   594,   577,   562,   535,    14,   564,   580,     0,     0,
       0,   243,     0,     0,     0,     0,   297,   297,   294,   283,
       0,     0,   632,     0,   590,    14,     0,   583,   632,     0,
       0,     0,     0,     0,     0,   251,   256,     0,     0,     0,
       0,   309,   431,   589,   595,   578,   554,    14,   622,     0,
     247,   246,   245,     0,   256,   236,     0,     0,     0,     0,
       0,    14,   584,   239,     0,     0,     0,     0,     0,     0,
       0,   555,     0,     0,     0,     0,     0,   288,     0,   285,
       0,   238,     0,     0,   252,     0,   257,   287,   284,   237,
       0,   257,     0,   253,     0,     0,     0,     0,     0,     0,
     254,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   255
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1099, -1099, -1099,   731,    66, -1099, -1099,    86, -1099, -1099,
    1206, -1099,  1205,    -8,    65, -1099, -1099, -1099,  1049, -1099,
   -1099, -1099,   771, -1099, -1099,   944, -1099,  -383,  -526,   832,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099,  -455, -1099, -1099, -1099, -1099, -1099,
   -1099,   -99,  -850,  -460,  -470, -1099, -1099,   407, -1099,  -313,
   -1099,   580,   777, -1099,   707, -1099,  -463,    45, -1099,   -47,
    -129,   -10,  -139,   338,  -571, -1099, -1099,  -450, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099,  1147,  1148,   793,  -339,
   -1099,  1274,   331, -1099, -1099, -1099,   737, -1099, -1099,   234,
   -1099,   559, -1099, -1099, -1099,    70, -1099,  -837, -1099,  2088,
   -1099, -1099,   557,  -593, -1099,   549,   457, -1099, -1099, -1099,
     369, -1025, -1099, -1099, -1099,   375, -1099,   105, -1015,  -905,
   -1072, -1099,  -287, -1099,   370,  -695,  -497, -1099,   110, -1099,
   -1099, -1099, -1099, -1099, -1099,   -80,     2, -1099,    25, -1099,
    1178,  -312, -1099,   863, -1099,   606,  1372, -1099, -1099,   -56,
     -17,   -75, -1099,   990, -1099, -1099,   492, -1099, -1099, -1099,
    1375, -1099,   983,   826, -1099, -1099, -1099,  1107, -1099,   906,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,   328,  -453,
   -1099, -1099, -1099, -1099,   561, -1099,   294,  -482,   919, -1099,
     568,  1317,    47,  1399, -1099, -1099, -1099, -1099, -1099, -1099,
    -925,  -355, -1099, -1099, -1099, -1099, -1099,   260, -1099,   522,
   -1099,   759, -1054, -1099,   579, -1099, -1099,   953, -1099, -1099,
   -1099, -1099, -1099, -1099,  -337,  -647,  -550,    41, -1099, -1099,
   -1099, -1099, -1099,   398,   508, -1099, -1099, -1099, -1098,   716,
    -136, -1099,  -575, -1099, -1099, -1099, -1099, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099,   831, -1099, -1099, -1099,
   -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099, -1099,   180,
   -1099,    55,  -588,   532,  -639,   587, -1099,   876,   498,   325,
     497, -1099,  -569, -1099, -1099, -1099, -1099, -1099,  -545, -1099,
   -1099, -1092, -1099, -1099,   -76,  1016, -1099,   460,   -82
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     8,   595,    10,    51,   596,    20,    96,
      62,    63,    64,   135,    35,    12,    87,   257,   183,   379,
     533,   466,   467,   607,   608,   280,   384,   390,   535,   385,
     469,   470,   612,   739,    13,    90,   268,   453,   513,    14,
      21,   101,   479,   553,    15,    43,   146,   361,    85,   148,
     255,    86,   804,   597,   633,   472,   473,   474,   475,   641,
     541,   737,   544,   731,   623,   624,   625,    36,    37,    77,
      78,    79,    80,   579,   880,   671,   975,    16,   269,   458,
     584,   276,   374,   375,   173,   174,    71,    74,   455,   371,
     456,    93,   378,   463,   698,   526,   527,   801,   528,   529,
     673,   766,   767,  1323,   768,  1122,  1190,   951,  1284,  1285,
     674,   772,   773,   675,   781,   782,   783,   775,   776,   777,
    1051,  1136,   959,   868,   869,   960,  1048,  1195,  1049,   961,
    1196,   778,   967,   968,   872,   969,  1197,   863,   154,   155,
     156,   260,   157,   158,   159,   160,   598,    88,   599,    89,
     263,   264,   265,   678,   629,   630,   679,    67,   105,   161,
     162,   187,   282,   283,   388,   793,   794,   680,   681,   886,
     790,    75,    40,   110,   111,   191,   285,   286,   394,   395,
     483,   287,   288,   399,   400,   565,   401,   978,   979,   600,
     842,  1103,   840,   841,   931,  1018,  1019,  1020,   683,   744,
     745,    83,   601,   136,    42,   685,   885,   980,   791,  1062,
    1068,  1064,   576,  1065,  1203,   509,  1069,  1070,  1071,   448,
     573,   574,   756,   757,   758,   642,   643,   686,   752,   937,
     751,   747,   845,  1026,  1027,   581,   602,   822,   562,   743,
     928,   835,   924,   925,   926,   927,   603,   688,   604,   318,
     137,   994,   605,   814,   806,   807,   990,   903,  1221,  1311,
    1088,  1089,  1084,  1219,  1098,   606,   689,  1174,  1083,  1253,
    1275,  1227,  1257,  1258,  1297,  1156,  1215,  1216,  1272,  1249,
    1250,   138,   720,   812,   854,   499,   500,   501,   785,   881,
     947,   948,   882,   857,  1186,  1033,  1079,   759,  1115,   761,
     943,  1116,  1117,  1183,  1286,   140,   325,   210,   141
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     139,   478,   220,   514,    17,   253,   215,   760,   670,   163,
     690,   106,    65,    17,    17,    17,    17,    17,    17,    17,
      17,    17,   721,   180,   554,   953,   558,    18,  1127,   687,
     142,   143,   188,  1131,   691,    84,    18,    18,    18,    18,
      18,    18,    18,    18,    18,   746,   591,   987,   256,    19,
     107,  1063,   451,   217,  1043,   208,   209,    61,    19,    19,
      19,    19,    19,    19,    19,    19,    19,   468,     9,   774,
     476,   769,   945,    61,    98,    69,     3,     9,     9,     9,
       9,     9,     9,     9,     9,     9,   730,    65,    11,    65,
    1228,   632,   165,   508,  1206,    98,   934,    11,    11,    11,
      11,    11,    11,    11,    11,    11,  -229,   258,  1200,   511,
     820,    81,   104,   519,   855,   920,   570,   520,   319,   521,
     380,    82,   764,   262,   669,   216,   682,  1238,   320,   672,
     380,  1260,    28,   104,   104,    61,    70,   324,   172,    84,
      33,   258,  1129,   589,   259,   329,   330,   331,    72,   921,
     922,   946,   734,   153,   153,   221,   222,  1276,   171,  1302,
     901,   738,   495,  1267,  1268,   779,   784,   900,   143,   955,
     120,   121,   839,     6,   765,   908,   843,  1241,   284,   774,
    1293,    68,   973,   821,   196,   197,  1298,    66,  1271,   199,
     200,   201,   202,   203,   204,   205,   206,   820,   215,   211,
     212,   214,   100,   219,   701,   702,   703,    91,   213,    73,
      76,   327,   587,   831,   402,   403,   404,   405,  1204,   367,
     468,   716,   652,   100,    92,  1198,   935,   909,   376,   223,
    1157,   224,   397,   780,   407,   687,   936,   716,    95,   406,
     883,   408,   409,   410,   410,   693,   108,   166,   746,    97,
     415,  1288,  1290,   167,   294,   294,   294,   294,   294,   294,
     294,   294,   489,   449,   -53,   261,   294,   294,  1052,  1052,
     821,   398,   266,   923,   328,   779,   381,   -42,   382,  -241,
     185,   -42,   445,   446,   784,  1108,   381,    98,   -53,  1056,
     452,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   216,   359,   895,
     548,   887,   486,   487,   189,   549,   550,  -592,   704,  1273,
     669,   632,   682,   104,  -592,   672,  1274,   545,   502,   551,
     825,   186,   113,    98,   109,   383,   910,   911,   115,   913,
     116,  1230,   150,   396,    84,  1133,   632,   632,   -14,   632,
     145,   705,  1029,   364,   769,   592,   735,  1057,   365,    98,
     962,  1058,   933,  -482,  -482,  -482,  -482,   649,   784,  1109,
       4,   650,   632,  1110,   149,   190,     6,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   152,    99,   100,   828,   829,     7,   566,
     177,   -13,   957,   958,   592,  1287,   920,   736,   147,   571,
     575,   593,  -482,  -482,  -482,  -482,   258,  1289,   364,     4,
    1202,   184,   294,   368,     4,   465,   221,   222,   696,   120,
     121,   699,     6,   164,     5,   515,  1045,  1046,   611,   718,
     921,   922,   962,   250,   251,  1047,  1126,  1181,  1054,  1055,
     484,   100,  -545,   563,  -545,   485,   897,   213,   516,   175,
     898,   555,   687,  1045,  1046,  1045,  1046,   883,   694,   670,
     327,   690,  1236,   502,  1047,  1045,  1046,   100,   -14,   113,
     517,   258,   750,   213,   556,   115,   179,   116,  1160,  1161,
     687,     6,  1218,  1165,  1166,   691,     6,   530,   531,   512,
     223,   594,   413,   769,   181,   592,   560,   728,   729,   525,
    1045,  1046,   577,  -482,  -482,  -482,  -482,   578,   628,  1130,
       4,  1012,   741,   383,   192,   552,   836,   742,     7,   769,
     962,   837,   193,   568,   592,   875,    45,    46,  1031,   182,
     876,   888,  -482,  -482,  -482,  -482,   889,   687,   194,     4,
    1080,   875,  1159,   575,  1081,   770,   971,   669,  1015,   682,
     594,   676,   672,  1016,   542,   543,  1015,   717,   215,   626,
      48,  1017,  1307,   195,  1309,  1236,   771,   663,   465,  1237,
      49,   770,    50,  1066,   677,   669,  1143,   682,  1067,   622,
     672,  1144,     6,  1318,  1146,  1320,    22,    23,   695,  1147,
     327,   289,   865,   663,  1333,   327,   684,  1342,  1334,   805,
     254,  1343,   198,   962,   247,   248,   249,   250,   251,  1349,
     813,     6,   218,  1350,   262,   667,   168,   169,    26,   270,
     719,   271,   104,   104,   525,  -110,  -110,  -110,   626,   272,
     626,   274,   669,   277,   682,   668,   278,   672,   279,   626,
     949,   950,   153,   153,   538,   539,   540,   847,   622,   850,
     622,   594,   912,   740,  1225,  1226,   856,   592,   719,   622,
     722,   723,   724,   725,   258,  -482,  -482,  -482,  -482,   281,
    1295,   290,     4,   291,   873,   460,   461,   216,    22,    23,
     594,    29,    30,    31,    32,   170,   292,   755,   795,   796,
     797,   798,  1312,   894,   954,   102,   103,    26,   293,    22,
      23,   628,   902,   321,   904,   905,  1321,   326,   102,   103,
      26,   150,    52,    53,    54,    55,    56,    57,    58,    59,
      60,   918,   658,   659,   660,   358,   919,   585,   586,   102,
     103,    26,   930,    34,   823,   824,   826,    22,    23,  1137,
    1138,  1178,  1179,   360,     6,   366,   362,   502,   151,   411,
     412,   370,   369,   952,   815,   372,   818,   676,   956,   373,
      29,    30,    31,    32,   377,   956,   389,    24,    25,    26,
     386,   956,   152,    29,    30,    31,    32,   327,   387,   393,
     677,   245,   246,   247,   248,   249,   250,   251,   416,   391,
     414,   805,   447,   988,    29,    30,    31,    32,   327,   454,
     417,   813,   684,   418,   999,  1000,   457,  1001,  1003,  1005,
    1007,  1009,   459,   594,   462,   -59,   464,    27,   471,   477,
     495,   879,   490,   482,   491,    34,   319,   498,   492,    28,
    1028,   493,    29,    30,    31,    32,   494,    33,   496,   497,
     719,   668,   503,   251,   504,  1037,    34,  1039,   505,   507,
     506,    44,   518,    45,    46,   510,    47,   956,   956,    61,
     522,   719,   523,   524,   873,   706,  -229,   532,   536,   534,
     547,   537,   567,   569,   590,   583,  1073,  1075,  1077,  1078,
     588,   580,    45,    46,    34,   614,   610,    48,   755,   627,
     631,   594,   645,  -110,  -110,  -110,  1090,    49,  1092,    50,
    1094,   647,   648,   651,   692,   700,   726,   748,   749,   707,
     753,   708,   786,   709,   710,   711,   258,  1105,  1106,   762,
     763,  -565,  -565,  -565,  1112,   792,   799,   800,   802,  1119,
    1120,   808,   809,   810,   811,  1124,   832,   827,   838,   834,
     860,   853,   639,   640,  1134,   851,   858,   852,   859,   870,
     956,   956,   844,  1086,   862,   864,   120,   121,   712,   713,
     714,   867,    22,    23,   871,   769,  1149,   884,  1151,   877,
    1153,   890,   891,   892,   805,   893,  1158,   896,   899,  1162,
     592,  1164,   653,   906,  1142,   907,   914,   939,  -482,  -482,
    -482,  -482,   733,   620,    26,     4,   915,   916,  1177,   917,
     942,   548,  1028,  1028,   676,   938,   944,   970,   963,   964,
     977,   992,  1185,   982,   983,  1187,   986,  1191,   715,   984,
     551,   985,   989,   716,   998,  1011,   655,   677,   656,   956,
     657,   991,   676,   995,   996,  1010,   920,  1014,   658,   659,
     660,   945,  1041,  1021,  1030,  1044,  1035,   661,   662,   684,
     663,  1036,  1038,   664,  1040,   677,  1061,    29,    30,    31,
      32,  1082,  1087,  1091,  1085,  1096,    27,     6,   879,  1093,
     665,  1141,  1095,  1097,  1100,  1101,  1102,   684,  1104,  1107,
     655,  1118,  1113,  1231,  1121,  1123,  1233,  1125,   668,   676,
    1128,  1132,  1135,   718,  1139,  1240,   667,  1140,  1148,     7,
    1150,  1152,  1154,  1155,  1163,  1167,  1182,  1168,  1170,    34,
    1251,  1169,   677,  1171,  1254,  1172,   668,  1173,  1176,  1180,
    1188,  1192,  1193,  1194,  1261,  1199,  1207,  1209,   112,    61,
     113,   114,  1208,  1210,   684,   666,   115,  1211,   116,    22,
      23,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,  1251,   879,  1212,  1213,  1280,  1281,  1282,  1214,
    1217,  1220,   848,  1222,  1291,  1234,  1223,  1294,  1252,    24,
      25,    26,   117,   668,  1224,  1229,  1232,  1304,  1235,  1244,
    1239,   956,  1242,   956,   755,   295,   296,   297,   298,   299,
     300,   301,   302,  1243,  1265,  1256,  1245,   322,   323,  1246,
    1316,  1255,   956,  1269,   956,  1270,  1278,  1292,  1296,  1325,
      22,    23,  1299,  1300,   118,   119,  1305,  1301,    22,    23,
    1336,   327,  1306,  1308,  1310,  1314,   120,   121,  1317,  1341,
    1319,  1322,  1327,   122,    29,    30,    31,    32,  1339,  1326,
     615,   620,    26,  1328,  1329,   616,   617,   618,   619,   620,
      26,  1330,  1335,  1332,  1337,  1338,   123,   124,   125,   126,
     127,   128,  1345,  1347,  1352,  1259,  1354,  1356,  1358,  1362,
    1360,   176,   178,   609,   129,   130,   363,   450,   755,   546,
     993,   830,   582,  1060,   719,   849,   131,   621,   613,   273,
     732,  1259,   275,   132,    94,   697,   861,   133,   134,   866,
     874,  1279,   972,  1053,  1042,    29,    30,    31,    32,  1266,
    1059,   267,   557,    29,    30,    31,    32,   833,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   112,    61,   113,   114,    38,   481,
     981,    39,   115,   488,   116,    22,    23,    34,    45,    46,
     564,   644,   392,  1022,  1145,    34,  1175,   144,   559,  -110,
    -110,  -110,   932,   480,   929,    41,  1205,   976,   754,  1099,
     634,   635,   636,   637,   638,    24,    25,    26,   117,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   940,   561,  1023,  1024,  1013,   819,   727,  1277,   997,
     941,  1032,  1184,  1034,     0,   646,   816,     0,   639,   640,
       0,     0,     0,     0,   112,    61,   113,   114,     0,     0,
     118,   119,   115,   817,   116,    22,    23,     0,     0,     0,
       0,     0,   120,   121,     0,     0,     0,     0,     0,   122,
      29,    30,    31,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,    25,    26,   117,     0,
       0,     0,   123,   124,   125,   126,   127,   128,     0,     0,
       0,     0,     0,   965,   966,     0,     0,     0,     0,     0,
     129,   130,  1025,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   131,     0,     0,     0,     0,     0,     0,   132,
     118,   119,     0,   133,   134,     0,     0,     0,     0,     0,
       0,     0,   120,   121,     0,     0,     0,     0,     0,   122,
      29,    30,    31,    32,     0,     0,   112,    61,   113,   114,
       0,     0,     0,     0,   115,     0,   116,    22,    23,     0,
       0,     0,   123,   124,   125,   126,   127,   128,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,    24,    25,    26,
     117,     0,   131,     0,     0,     0,     0,     0,     0,   132,
       0,     0,     0,   133,   134,  1023,  1024,     0,     0,     0,
       0,     0,     0,     0,     0,   112,    61,   113,   114,     0,
    1247,     0,     0,   115,     0,   116,    22,    23,     0,     0,
       0,     0,   118,   119,     0,     0,     0,     0,  1262,  1263,
       0,     0,     0,     0,   120,   121,     0,     0,     0,     0,
       0,   122,    29,    30,    31,    32,    24,    25,    26,   117,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   123,   124,   125,   126,   127,   128,
       0,     0,  1248,     0,     0,     0,     0,     0,   112,    61,
     113,   114,   129,   130,     0,     0,   115,     0,   116,    22,
      23,   118,   119,     0,   131,     0,   315,     0,     0,   316,
       0,   132,  1264,   120,   121,   133,   134,     0,     0,     0,
     122,    29,    30,    31,    32,     0,     0,     0,     0,    24,
      25,    26,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   123,   124,   125,   126,   127,   128,     0,
       0,     0,     0,     0,     0,     0,     0,   112,    61,   113,
     114,   129,   130,     0,     0,   115,     0,   116,    22,    23,
       0,     0,     0,   131,   118,   119,     0,     0,     0,     0,
     132,     0,     0,     0,   133,   134,   120,   121,     0,     0,
       0,     0,     0,   122,    29,    30,    31,    32,    24,    25,
      26,   117,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   123,   124,   125,   126,
     127,   128,     0,     0,     0,     0,     0,     0,     0,     0,
     112,    61,   113,   114,   129,   130,     0,     0,   115,     0,
     116,    22,    23,   118,   119,   572,   131,     0,   315,     0,
       0,   316,     0,   132,   317,   120,   121,   133,   134,     0,
       0,     0,   122,    29,    30,    31,    32,     0,     0,     0,
       0,    24,    25,    26,   117,     0,     0,     0,     0,     0,
       0,     0,   803,     0,     0,   123,   124,   125,   126,   127,
     128,     0,     0,     0,     0,     0,     0,     0,     0,   112,
      61,   113,   114,   129,   130,     0,     0,   115,     0,   116,
      22,    23,     0,     0,     0,   131,   118,   119,     0,     0,
       0,     0,   132,     0,     0,     0,   133,   134,   120,   121,
       0,     0,     0,     0,     0,   122,    29,    30,    31,    32,
      24,    25,    26,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   123,   124,
     125,   126,   127,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,     0,   118,   119,     0,   131,   846,
       0,     0,     0,     0,     0,   132,  1002,   120,   121,   133,
     134,     0,     0,     0,   122,    29,    30,    31,    32,   112,
      61,   113,   114,     0,     0,     0,     0,   115,     0,   116,
      22,    23,     0,     0,     0,     0,     0,   123,   124,   125,
     126,   127,   128,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   129,   130,     0,     0,     0,
      24,    25,    26,   117,     0,     0,     0,   131,     0,     0,
       0,     0,     0,     0,   132,     0,     0,     0,   133,   134,
       0,     0,     0,     0,     0,     0,     0,     0,   112,    61,
     113,   114,     0,     0,     0,     0,   115,     0,   116,    22,
      23,     0,     0,     0,     0,   118,   119,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1004,   120,   121,     0,
       0,     0,     0,     0,   122,    29,    30,    31,    32,    24,
      25,    26,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   123,   124,   125,
     126,   127,   128,     0,     0,     0,     0,     0,     0,     0,
       0,   112,    61,   113,   114,   129,   130,     0,     0,   115,
       0,   116,    22,    23,   118,   119,     0,   131,     0,     0,
       0,     0,     0,     0,   132,  1006,   120,   121,   133,   134,
       0,     0,     0,   122,    29,    30,    31,    32,     0,     0,
       0,     0,    24,    25,    26,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   123,   124,   125,   126,
     127,   128,     0,     0,     0,     0,     0,     0,     0,     0,
     112,    61,   113,   114,   129,   130,     0,     0,   115,     0,
     116,    22,    23,     0,     0,     0,   131,   118,   119,     0,
       0,     0,     0,   132,     0,     0,     0,   133,   134,   120,
     121,     0,     0,     0,     0,     0,   122,    29,    30,    31,
      32,    24,    25,    26,   117,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   123,
     124,   125,   126,   127,   128,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   129,   130,     0,
       0,     0,     0,     0,     0,     0,   118,   119,     0,   131,
    1008,     0,     0,     0,     0,     0,   132,  1072,   120,   121,
     133,   134,     0,     0,     0,   122,    29,    30,    31,    32,
     112,    61,   113,   114,     0,     0,     0,     0,   115,     0,
     116,    22,    23,     0,     0,     0,     0,     0,   123,   124,
     125,   126,   127,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   129,   130,     0,     0,
       0,    24,    25,    26,   117,     0,     0,     0,   131,     0,
       0,     0,     0,     0,     0,   132,     0,     0,     0,   133,
     134,     0,     0,     0,     0,     0,     0,     0,     0,   112,
      61,   113,   114,     0,     0,     0,     0,   115,     0,   116,
      22,    23,     0,     0,     0,     0,   118,   119,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1074,   120,   121,
       0,     0,     0,     0,     0,   122,    29,    30,    31,    32,
      24,    25,    26,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   123,   124,
     125,   126,   127,   128,     0,     0,     0,     0,     0,     0,
       0,     0,   112,    61,   113,   114,   129,   130,     0,     0,
     115,     0,   116,    22,    23,   118,   119,     0,   131,     0,
       0,     0,     0,     0,     0,   132,  1076,   120,   121,   133,
     134,     0,     0,     0,   122,    29,    30,    31,    32,     0,
       0,     0,     0,    24,    25,    26,   117,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   123,   124,   125,
     126,   127,   128,     0,     0,     0,     0,     0,     0,     0,
       0,   112,    61,   113,   114,   129,   130,     0,     0,   115,
       0,   116,    22,    23,     0,     0,     0,   131,   118,   119,
       0,     0,     0,     0,   132,     0,     0,     0,   133,   134,
     120,   121,     0,     0,     0,     0,     0,   122,    29,    30,
      31,    32,    24,    25,    26,   117,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     123,   124,   125,   126,   127,   128,     0,     0,     0,     0,
       0,     0,     0,     0,   112,    61,   113,   114,   129,   130,
       0,     0,   115,     0,   116,   207,    23,   118,   119,     0,
     131,  1111,   315,     0,     0,   316,     0,   132,  1201,   120,
     121,   133,   134,     0,     0,     0,   122,    29,    30,    31,
      32,     0,     0,     0,     0,    24,    25,    26,   117,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   123,
     124,   125,   126,   127,   128,     0,     0,     0,     0,     0,
       0,     0,     0,   112,    61,   113,   114,   129,   130,     0,
       0,   115,     0,   116,    22,    23,     0,     0,     0,   131,
     118,   119,     0,     0,     0,     0,   132,     0,     0,     0,
     133,   134,   120,   121,     0,     0,     0,     0,     0,   122,
      29,    30,    31,    32,    24,    25,    26,   117,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   123,   124,   125,   126,   127,   128,     0,     0,
       0,     0,     0,     0,     0,     0,   112,    61,   113,   114,
     129,   130,     0,     0,   115,     0,   116,    22,    23,   118,
     119,     0,   131,     0,   315,     0,     0,   316,     0,   132,
    1315,   120,   121,   133,   134,     0,     0,     0,   122,    29,
      30,    31,    32,     0,     0,     0,     0,    24,    25,    26,
     117,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   123,   124,   125,   126,   127,   128,     0,     0,     0,
       0,     0,     0,     0,     0,   112,    61,   113,   114,   129,
     130,     0,     0,   115,     0,   116,    22,    23,     0,     0,
       0,  1050,   118,   119,     0,     0,     0,     0,   132,     0,
       0,     0,   133,   134,   120,   121,     0,     0,     0,     0,
       0,   122,    29,    30,    31,    32,    24,    25,    26,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   123,   124,   125,   126,   127,   128,
       0,     0,     0,     0,     0,     0,     0,     0,   112,    61,
     113,   114,   129,   130,     0,     0,   115,     0,   116,    22,
      23,   118,   119,     0,  1189,     0,     0,     0,     0,     0,
       0,   132,     0,   120,   121,   133,   134,     0,     0,     0,
     122,    29,    30,    31,    32,     0,     0,     0,     0,    24,
      25,    26,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   123,   124,   125,   126,   127,   128,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   129,   130,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,   118,   119,     0,     0,     0,     0,
     132,     0,     0,     0,   133,   134,     0,     0,     0,     0,
       0,     0,     0,   122,    29,    30,    31,    32,     0,     0,
       0,     0,   787,     0,     0,   788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   123,   124,   125,   126,
     127,   128,     0,     0,     0,    45,    46,     0,     0,     0,
       0,     0,     0,     0,   129,   130,  -110,  -110,  -110,     0,
       0,     0,     0,     0,     0,     0,   131,   634,   635,   636,
     637,   638,     0,   132,     0,     0,     0,   133,   134,    48,
       0,     0,   789,     0,     0,     0,     0,     0,     0,    49,
       0,    50,     0,   592,     0,   653,     0,     0,     0,     0,
       0,  -482,  -482,  -482,  -482,   639,   640,     0,     4,     0,
       0,   654,     0,     0,   548,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,   592,     0,   653,
       0,     0,    33,   551,     0,  -482,  -482,  -482,  -482,   655,
       0,   656,     4,   657,     0,     0,     0,     0,   548,     0,
       0,   658,   659,   660,     0,     0,     0,     0,     0,     0,
     661,   662,     0,   663,     0,     0,   664,   551,     0,     0,
       0,     0,     0,   655,     0,   656,     0,   657,     0,    27,
       6,   974,     0,   665,     0,   658,   659,   660,     0,     0,
       0,     0,     0,     0,   661,   662,     0,   663,     0,     0,
     664,   878,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,    27,     6,     0,   592,   665,   653,     0,
       0,     0,     0,     0,  -482,  -482,  -482,  -482,     0,     0,
       0,     4,     0,     0,     0,     0,     0,   548,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     0,   666,     0,
     592,     0,   653,     0,     0,     0,   551,     0,  -482,  -482,
    -482,  -482,   655,  1114,   656,     4,   657,     0,     0,     0,
       0,   548,     0,     0,   658,   659,   660,     0,     0,     0,
       0,     0,     0,   661,   662,     0,   663,     0,     0,   664,
     551,     0,     0,     0,     0,     0,     0,     0,   656,     0,
     657,     0,    27,     6,     0,     0,   665,     0,   658,   659,
     660,     0,     0,     0,     0,     0,     0,   661,   662,   787,
     663,     0,   788,   664,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     7,    27,     6,     0,     0,
     665,     0,    45,    46,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -110,  -110,  -110,     0,     0,     0,     0,
       0,  1303,     0,     0,   634,   635,   636,   637,   638,     7,
       0,     0,     0,     0,     0,     0,    48,  1313,     0,   789,
       0,     0,     0,     0,     0,     0,    49,     0,    50,     0,
       0,     0,  1324,     0,     0,     0,     0,     0,     0,     0,
    1331,     0,   639,   640,     0,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,     0,
    1344,    28,     0,  1346,     0,  1348,     0,  1351,     0,    33,
    1353,     0,  1355,     0,  1357,     0,  1359,     0,  1361,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251
};

static const yytype_int16 yycheck[] =
{
      76,   384,   138,   453,     2,   144,   135,   654,   579,    89,
     579,    67,    20,    11,    12,    13,    14,    15,    16,    17,
      18,    19,   597,    99,   479,   862,   479,     2,  1043,   579,
      77,    78,   107,  1048,   579,    43,    11,    12,    13,    14,
      15,    16,    17,    18,    19,   633,   528,   897,   147,     2,
      67,   976,   364,   135,   959,   131,   132,     4,    11,    12,
      13,    14,    15,    16,    17,    18,    19,   379,     2,   662,
     383,     4,     4,     4,    32,    47,     0,    11,    12,    13,
      14,    15,    16,    17,    18,    19,   612,    95,     2,    97,
    1182,   551,     4,   448,  1148,    32,    21,    11,    12,    13,
      14,    15,    16,    17,    18,    19,     4,   154,  1133,    31,
      20,     4,    67,   158,   761,     4,   499,   162,   158,   458,
       4,    14,     4,     4,   579,   135,   579,  1199,   168,   579,
       4,  1229,   106,    88,    89,     4,   108,   213,    93,   147,
     114,   188,  1047,   526,   154,   221,   222,   223,    47,    38,
      39,    83,   615,    88,    89,    91,    92,  1255,    93,   162,
     807,   624,   165,  1235,  1236,   662,   663,   806,   215,   864,
     101,   102,   747,    95,    56,   814,   751,  1202,   188,   772,
    1272,    14,   877,    93,   118,   119,  1278,     4,  1242,   123,
     124,   125,   126,   127,   128,   129,   130,    20,   327,   133,
     134,   135,   160,   137,     4,     5,     6,     4,   166,   108,
     166,   219,   525,   739,   290,   291,   292,   293,  1143,   266,
     532,   168,   577,   160,    65,  1130,   151,   815,   275,   165,
    1080,   167,   288,   166,   316,   785,   161,   168,    21,   315,
     785,   317,   318,   319,   320,   584,   162,   159,   836,   158,
     326,  1266,  1267,   165,   199,   200,   201,   202,   203,   204,
     205,   206,   401,   362,   162,   155,   211,   212,   963,   964,
      93,   288,   162,   162,   219,   772,   160,   158,   162,   161,
      47,   162,   358,   359,   781,    64,   160,    32,   162,    80,
     366,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   327,   252,   801,
      29,   791,   397,   398,    47,    34,    35,   158,   128,   158,
     785,   791,   785,   288,   165,   785,   165,   476,   414,    48,
     163,   108,     5,    32,   107,   279,   816,   817,    11,   819,
      13,  1188,    47,   288,   362,  1050,   816,   817,    21,   819,
     163,   161,   937,   158,     4,     8,    47,   158,   163,    32,
     867,   162,   842,    16,    17,    18,    19,   158,   875,   158,
      23,   162,   842,   162,     4,   108,    95,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   108,   159,   160,   728,   729,   127,   495,
      24,     0,    62,    63,     8,    91,     4,   108,   165,   505,
     506,    74,    16,    17,    18,    19,   483,    91,   158,    23,
    1135,   168,   387,   163,    23,   379,    91,    92,   587,   101,
     102,   590,    95,     4,    33,   453,   149,   150,   534,   595,
      38,    39,   959,   154,   155,   158,   159,  1114,   965,   966,
     158,   160,   161,   483,   163,   163,   158,   166,   453,     4,
     162,   479,  1032,   149,   150,   149,   150,  1032,    72,  1060,
     498,  1060,   158,   569,   158,   149,   150,   160,   161,     5,
     453,   548,   641,   166,   479,    11,     4,    13,  1083,  1084,
    1060,    95,  1159,  1088,  1089,  1060,    95,    27,    28,   453,
     165,   164,   167,     4,     4,     8,   479,   607,   608,   463,
     149,   150,   158,    16,    17,    18,    19,   163,   548,   158,
      23,   924,   158,   477,   168,   479,   158,   163,   127,     4,
    1047,   163,    11,   498,     8,   158,    27,    28,   941,   164,
     163,   158,    16,    17,    18,    19,   163,  1117,    12,    23,
     158,   158,    55,   649,   162,    56,   163,  1032,   158,  1032,
     164,   579,  1032,   163,    96,    97,   158,   595,   717,   544,
      61,   163,  1287,   155,  1289,   158,    77,    78,   532,   162,
      71,    56,    73,   158,   579,  1060,   158,  1060,   163,   544,
    1060,   163,    95,  1308,   158,  1310,    14,    15,    72,   163,
     628,    12,    77,    78,   158,   633,   579,   158,   162,   705,
       4,   162,   155,  1130,   151,   152,   153,   154,   155,   158,
     716,    95,   155,   162,     4,   579,    44,    45,    46,     4,
     595,     4,   607,   608,   588,    38,    39,    40,   613,     4,
     615,     4,  1117,    22,  1117,   579,   161,  1117,   161,   624,
      62,    63,   607,   608,    38,    39,    40,   753,   613,   755,
     615,   164,   818,   628,    85,    86,   762,     8,   633,   624,
      16,    17,    18,    19,   741,    16,    17,    18,    19,     4,
    1275,   161,    23,   161,   780,   374,   375,   717,    14,    15,
     164,   109,   110,   111,   112,   113,   161,   651,    16,    17,
      18,    19,  1297,   799,   863,    44,    45,    46,   161,    14,
      15,   741,   808,   169,   810,   811,  1311,   161,    44,    45,
      46,    47,    11,    12,    13,    14,    15,    16,    17,    18,
      19,   827,    66,    67,    68,   161,   832,   523,   524,    44,
      45,    46,   838,   161,   723,   724,   725,    14,    15,  1056,
    1057,  1108,  1109,   163,    95,   159,   158,   853,    84,   319,
     320,   161,   163,   859,   718,     4,   720,   785,   864,   159,
     109,   110,   111,   112,   161,   871,   158,    44,    45,    46,
     163,   877,   108,   109,   110,   111,   112,   815,   159,     4,
     785,   149,   150,   151,   152,   153,   154,   155,   167,   169,
     161,   897,   164,   899,   109,   110,   111,   112,   836,     4,
     167,   907,   785,   167,   910,   911,   163,   913,   914,   915,
     916,   917,     4,   164,   162,     4,   163,    94,   160,   158,
     165,   785,   162,   169,   162,   161,   158,   160,   162,   106,
     936,   162,   109,   110,   111,   112,   162,   114,   162,   169,
     815,   785,   162,   155,   162,   951,   161,   953,   165,     4,
     161,    25,     4,    27,    28,   163,    30,   963,   964,     4,
       4,   836,   163,   163,   970,    10,     4,   158,     4,   159,
     162,   160,   169,   158,     4,   163,   982,   983,   984,   985,
     158,   165,    27,    28,   161,    97,   162,    61,   852,     4,
       4,   164,   162,    38,    39,    40,  1002,    71,  1004,    73,
    1006,   162,     4,   161,     4,   165,   163,     4,     4,    54,
     161,    56,     4,    58,    59,    60,   993,  1023,  1024,   161,
     161,    66,    67,    68,  1030,     4,   161,   163,   162,  1035,
    1036,   161,   161,   161,   161,  1041,   159,   161,   159,   161,
      77,   161,    87,    88,  1050,   162,   161,   158,   161,   163,
    1056,  1057,   170,   993,   161,   161,   101,   102,   103,   104,
     105,   161,    14,    15,   161,     4,  1072,   163,  1074,   159,
    1076,    93,    93,    93,  1080,    93,  1082,   162,   165,  1085,
       8,  1087,    10,   169,  1061,   158,   161,     4,    16,    17,
      18,    19,    44,    45,    46,    23,   161,   161,  1104,   161,
     163,    29,  1108,  1109,  1032,   162,   162,   165,   159,   159,
       4,     4,  1118,   161,   161,  1121,   162,  1123,   163,   161,
      48,   161,   163,   168,   163,   158,    54,  1032,    56,  1135,
      58,   162,  1060,   162,   162,   162,     4,   163,    66,    67,
      68,     4,   165,   162,   161,   151,   159,    75,    76,  1032,
      78,   163,   162,    81,   162,  1060,     4,   109,   110,   111,
     112,   165,   163,   162,   159,   163,    94,    95,  1032,   162,
      98,    99,   162,   162,   162,     4,   158,  1060,   159,   162,
      54,   159,   162,  1189,    79,     9,  1192,   151,  1032,  1117,
     144,   159,   158,  1259,   163,  1201,  1060,   167,   161,   127,
     162,   162,   162,   162,     4,   162,    57,   163,   163,   161,
    1216,   162,  1117,   162,  1220,   163,  1060,   163,   163,   162,
     158,   165,   144,   144,  1230,   144,   162,   162,     3,     4,
       5,     6,   163,   163,  1117,   163,    11,   162,    13,    14,
      15,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,  1258,  1117,   163,   163,  1262,  1263,  1264,    69,
     162,   159,    37,   163,  1270,   161,   163,  1273,    57,    44,
      45,    46,    47,  1117,   163,   163,   162,  1283,   161,   163,
     162,  1287,   161,  1289,  1148,   199,   200,   201,   202,   203,
     204,   205,   206,   162,   159,    69,   163,   211,   212,   163,
    1306,   163,  1308,   162,  1310,   165,   162,   162,   162,  1315,
      14,    15,   158,   162,    89,    90,   163,   162,    14,    15,
    1326,  1259,   165,   165,   165,   158,   101,   102,   162,  1335,
     162,   158,   162,   108,   109,   110,   111,   112,   163,   165,
      36,    45,    46,   162,   162,    41,    42,    43,    44,    45,
      46,   162,   165,   162,   162,   162,   131,   132,   133,   134,
     135,   136,   158,   158,   158,  1229,   158,   158,   158,   162,
     158,    95,    97,   532,   149,   150,   257,   363,  1242,   477,
     903,   731,   519,   975,  1259,   160,   161,    83,   541,   172,
     613,  1255,   174,   168,    50,   588,   767,   172,   173,   772,
     781,  1261,   875,   964,   959,   109,   110,   111,   112,  1234,
     970,   163,   479,   109,   110,   111,   112,   741,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,     3,     4,     5,     6,     6,   389,
     888,     6,    11,   400,    13,    14,    15,   161,    27,    28,
     484,   565,   285,    22,  1066,   161,  1102,    80,   479,    38,
      39,    40,   841,   387,   836,     6,  1146,   885,   649,  1011,
      49,    50,    51,    52,    53,    44,    45,    46,    47,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   852,   479,    62,    63,   927,   720,   606,  1258,   907,
     853,   943,  1117,   946,    -1,   569,   142,    -1,    87,    88,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,
      89,    90,    11,   159,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,   101,   102,    -1,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    45,    46,    47,    -1,
      -1,    -1,   131,   132,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,
     149,   150,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      89,    90,    -1,   172,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,    -1,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,   112,    -1,    -1,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    13,    14,    15,    -1,
      -1,    -1,   131,   132,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,   150,    -1,    -1,    -1,    -1,    -1,    44,    45,    46,
      47,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,    62,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,    -1,
       8,    -1,    -1,    11,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    89,    90,    -1,    -1,    -1,    -1,    91,    92,
      -1,    -1,    -1,    -1,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,   109,   110,   111,   112,    44,    45,    46,    47,
      -1,    -1,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   131,   132,   133,   134,   135,   136,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,   149,   150,    -1,    -1,    11,    -1,    13,    14,
      15,    89,    90,    -1,   161,    -1,   159,    -1,    -1,   162,
      -1,   168,   165,   101,   102,   172,   173,    -1,    -1,    -1,
     108,   109,   110,   111,   112,    -1,    -1,    -1,    -1,    44,
      45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,   132,   133,   134,   135,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,   149,   150,    -1,    -1,    11,    -1,    13,    14,    15,
      -1,    -1,    -1,   161,    89,    90,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   101,   102,    -1,    -1,
      -1,    -1,    -1,   108,   109,   110,   111,   112,    44,    45,
      46,    47,    -1,    -1,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   131,   132,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,   149,   150,    -1,    -1,    11,    -1,
      13,    14,    15,    89,    90,   160,   161,    -1,   159,    -1,
      -1,   162,    -1,   168,   165,   101,   102,   172,   173,    -1,
      -1,    -1,   108,   109,   110,   111,   112,    -1,    -1,    -1,
      -1,    44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   128,    -1,    -1,   131,   132,   133,   134,   135,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,   149,   150,    -1,    -1,    11,    -1,    13,
      14,    15,    -1,    -1,    -1,   161,    89,    90,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   101,   102,
      -1,    -1,    -1,    -1,    -1,   108,   109,   110,   111,   112,
      44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,   150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    -1,   161,   162,
      -1,    -1,    -1,    -1,    -1,   168,   100,   101,   102,   172,
     173,    -1,    -1,    -1,   108,   109,   110,   111,   112,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,   131,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,   150,    -1,    -1,    -1,
      44,    45,    46,    47,    -1,    -1,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    89,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,   108,   109,   110,   111,   112,    44,
      45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,   149,   150,    -1,    -1,    11,
      -1,    13,    14,    15,    89,    90,    -1,   161,    -1,    -1,
      -1,    -1,    -1,    -1,   168,   100,   101,   102,   172,   173,
      -1,    -1,    -1,   108,   109,   110,   111,   112,    -1,    -1,
      -1,    -1,    44,    45,    46,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,   132,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,   149,   150,    -1,    -1,    11,    -1,
      13,    14,    15,    -1,    -1,    -1,   161,    89,    90,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   101,
     102,    -1,    -1,    -1,    -1,    -1,   108,   109,   110,   111,
     112,    44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
     132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,   150,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    -1,   161,
     162,    -1,    -1,    -1,    -1,    -1,   168,   100,   101,   102,
     172,   173,    -1,    -1,    -1,   108,   109,   110,   111,   112,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,   131,   132,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,   150,    -1,    -1,
      -1,    44,    45,    46,    47,    -1,    -1,    -1,   161,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    89,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,   108,   109,   110,   111,   112,
      44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,   149,   150,    -1,    -1,
      11,    -1,    13,    14,    15,    89,    90,    -1,   161,    -1,
      -1,    -1,    -1,    -1,    -1,   168,   100,   101,   102,   172,
     173,    -1,    -1,    -1,   108,   109,   110,   111,   112,    -1,
      -1,    -1,    -1,    44,    45,    46,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,   149,   150,    -1,    -1,    11,
      -1,    13,    14,    15,    -1,    -1,    -1,   161,    89,    90,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     101,   102,    -1,    -1,    -1,    -1,    -1,   108,   109,   110,
     111,   112,    44,    45,    46,    47,    -1,    -1,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     131,   132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,   149,   150,
      -1,    -1,    11,    -1,    13,    14,    15,    89,    90,    -1,
     161,   162,   159,    -1,    -1,   162,    -1,   168,   165,   101,
     102,   172,   173,    -1,    -1,    -1,   108,   109,   110,   111,
     112,    -1,    -1,    -1,    -1,    44,    45,    46,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
     132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,   149,   150,    -1,
      -1,    11,    -1,    13,    14,    15,    -1,    -1,    -1,   161,
      89,    90,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   101,   102,    -1,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,   112,    44,    45,    46,    47,    -1,    -1,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   131,   132,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
     149,   150,    -1,    -1,    11,    -1,    13,    14,    15,    89,
      90,    -1,   161,    -1,   159,    -1,    -1,   162,    -1,   168,
     165,   101,   102,   172,   173,    -1,    -1,    -1,   108,   109,
     110,   111,   112,    -1,    -1,    -1,    -1,    44,    45,    46,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,   132,   133,   134,   135,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,   149,
     150,    -1,    -1,    11,    -1,    13,    14,    15,    -1,    -1,
      -1,   161,    89,    90,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,   109,   110,   111,   112,    44,    45,    46,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,   132,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,   149,   150,    -1,    -1,    11,    -1,    13,    14,
      15,    89,    90,    -1,   161,    -1,    -1,    -1,    -1,    -1,
      -1,   168,    -1,   101,   102,   172,   173,    -1,    -1,    -1,
     108,   109,   110,   111,   112,    -1,    -1,    -1,    -1,    44,
      45,    46,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,   132,   133,   134,   135,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   161,    89,    90,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,   109,   110,   111,   112,    -1,    -1,
      -1,    -1,     4,    -1,    -1,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,   132,   133,   134,
     135,   136,    -1,    -1,    -1,    27,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,   150,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   161,    49,    50,    51,
      52,    53,    -1,   168,    -1,    -1,    -1,   172,   173,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,     8,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    87,    88,    -1,    23,    -1,
      -1,    26,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   106,    -1,    -1,     8,    -1,    10,
      -1,    -1,   114,    48,    -1,    16,    17,    18,    19,    54,
      -1,    56,    23,    58,    -1,    -1,    -1,    -1,    29,    -1,
      -1,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    76,    -1,    78,    -1,    -1,    81,    48,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    56,    -1,    58,    -1,    94,
      95,   163,    -1,    98,    -1,    66,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    76,    -1,    78,    -1,    -1,
      81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    94,    95,    -1,     8,    98,    10,    -1,
      -1,    -1,    -1,    -1,    16,    17,    18,    19,    -1,    -1,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,   163,    -1,
       8,    -1,    10,    -1,    -1,    -1,    48,    -1,    16,    17,
      18,    19,    54,    55,    56,    23,    58,    -1,    -1,    -1,
      -1,    29,    -1,    -1,    66,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    76,    -1,    78,    -1,    -1,    81,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      58,    -1,    94,    95,    -1,    -1,    98,    -1,    66,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,     4,
      78,    -1,     7,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    94,    95,    -1,    -1,
      98,    -1,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,  1283,    -1,    -1,    49,    50,    51,    52,    53,   127,
      -1,    -1,    -1,    -1,    -1,    -1,    61,  1299,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,
      -1,    -1,  1314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1322,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1342,   106,    -1,  1345,    -1,  1347,    -1,  1349,    -1,   114,
    1352,    -1,  1354,    -1,  1356,    -1,  1358,    -1,  1360,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   171,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   175,   176,     0,    23,    33,    95,   127,   177,   178,
     179,   181,   189,   208,   213,   218,   251,   320,   322,   376,
     182,   214,    14,    15,    44,    45,    46,    94,   106,   109,
     110,   111,   112,   114,   161,   188,   241,   242,   330,   344,
     346,   377,   378,   219,    25,    27,    28,    30,    61,    71,
      73,   180,   177,   177,   177,   177,   177,   177,   177,   177,
     177,     4,   184,   185,   186,   187,     4,   331,    14,    47,
     108,   260,    47,   108,   261,   345,   166,   243,   244,   245,
     246,     4,    14,   375,   187,   222,   225,   190,   321,   323,
     209,     4,    65,   265,   265,    21,   183,   158,    32,   159,
     160,   215,    44,    45,   241,   332,   333,   334,   162,   107,
     347,   348,     3,     5,     6,    11,    13,    47,    89,    90,
     101,   102,   108,   131,   132,   133,   134,   135,   136,   149,
     150,   161,   168,   172,   173,   187,   377,   424,   455,   478,
     479,   482,   243,   243,   375,   163,   220,   165,   223,     4,
      47,    84,   108,   188,   312,   313,   314,   316,   317,   318,
     319,   333,   334,   319,     4,     4,   159,   165,    44,    45,
     113,   188,   241,   258,   259,     4,   184,    24,   186,     4,
     478,     4,   164,   192,   168,    47,   108,   335,   335,    47,
     108,   349,   168,    11,    12,   155,   178,   178,   155,   178,
     178,   178,   178,   178,   178,   178,   178,    14,   478,   478,
     481,   178,   178,   166,   178,   244,   245,   482,   155,   178,
     424,    91,    92,   165,   167,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   171,   246,     4,   224,   225,   191,   243,   245,
     315,   312,     4,   324,   325,   326,   312,   324,   210,   252,
       4,     4,     4,   260,     4,   261,   255,    22,   161,   161,
     199,     4,   336,   337,   245,   350,   351,   355,   356,    12,
     161,   161,   161,   161,   455,   479,   479,   479,   479,   479,
     479,   479,   479,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   159,   162,   165,   423,   158,
     168,   169,   479,   479,   478,   480,   161,   187,   455,   478,
     478,   478,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   161,   178,
     163,   221,   158,   192,   158,   163,   159,   243,   163,   163,
     161,   263,     4,   159,   256,   257,   243,   161,   266,   193,
       4,   160,   162,   178,   200,   203,   163,   159,   338,   158,
     201,   169,   351,     4,   352,   353,   188,   333,   334,   357,
     358,   360,   478,   478,   478,   478,   478,   482,   478,   478,
     478,   481,   481,   167,   161,   478,   167,   167,   167,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   478,   478,   164,   393,   225,
     199,   325,   478,   211,     4,   262,   264,   163,   253,     4,
     266,   266,   162,   267,   163,   178,   195,   196,   325,   204,
     205,   160,   229,   230,   231,   232,   233,   158,   201,   216,
     479,   337,   169,   354,   158,   163,   335,   335,   346,   246,
     162,   162,   162,   162,   162,   165,   162,   169,   160,   459,
     460,   461,   478,   162,   162,   165,   161,     4,   385,   389,
     163,    31,   178,   212,   251,   320,   322,   376,     4,   158,
     162,   263,     4,   163,   163,   178,   269,   270,   272,   273,
      27,    28,   158,   194,   159,   202,     4,   160,    38,    39,
      40,   234,    96,    97,   236,   246,   203,   162,    29,    34,
      35,    48,   178,   217,   218,   320,   322,   327,   363,   372,
     376,   401,   412,   245,   353,   359,   478,   169,   455,   158,
     201,   478,   160,   394,   395,   478,   386,   158,   163,   247,
     165,   409,   262,   163,   254,   273,   273,   233,   158,   201,
       4,   371,     8,    74,   164,   178,   181,   227,   320,   322,
     363,   376,   410,   420,   422,   426,   439,   197,   198,   196,
     162,   478,   206,   236,    97,    36,    41,    42,    43,    44,
      45,    83,   188,   238,   239,   240,   241,     4,   245,   328,
     329,     4,   227,   228,    49,    50,    51,    52,    53,    87,
      88,   233,   399,   400,   347,   162,   461,   162,     4,   158,
     162,   161,   385,    10,    26,    54,    56,    58,    66,    67,
      68,    75,    76,    78,    81,    98,   163,   178,   181,   218,
     248,   249,   251,   274,   284,   287,   320,   322,   327,   330,
     341,   342,   363,   372,   376,   379,   401,   410,   421,   440,
     466,   472,     4,   263,    72,    72,   246,   270,   268,   246,
     165,     4,     5,     6,   128,   161,    10,    54,    56,    58,
      59,    60,   103,   104,   105,   163,   168,   187,   424,   455,
     456,   426,    16,    17,    18,    19,   163,   440,   319,   319,
     202,   237,   238,    44,   240,    47,   108,   235,   240,   207,
     455,   158,   163,   413,   373,   374,   456,   405,     4,     4,
     246,   404,   402,   161,   395,   178,   396,   397,   398,   471,
     409,   473,   161,   161,     4,    56,   275,   276,   278,     4,
      56,    77,   285,   286,   287,   291,   292,   293,   305,   310,
     166,   288,   289,   290,   310,   462,     4,     4,     7,    64,
     344,   382,     4,   339,   340,    16,    17,    18,    19,   161,
     163,   271,   162,   128,   226,   478,   428,   429,   161,   161,
     161,   161,   457,   478,   427,   178,   142,   159,   178,   423,
      20,    93,   411,   411,   411,   163,   411,   161,   325,   325,
     235,   202,   159,   329,   161,   415,   158,   163,   159,   426,
     366,   367,   364,   426,   170,   406,   162,   478,    37,   160,
     478,   162,   158,   161,   458,   409,   478,   467,   161,   161,
      77,   275,   161,   311,   161,    77,   286,   161,   297,   298,
     163,   161,   308,   478,   289,   158,   163,   159,    82,   178,
     248,   463,   466,   472,   163,   380,   343,   228,   158,   163,
      93,    93,    93,    93,   478,   371,   162,   158,   162,   165,
     458,   409,   478,   431,   478,   478,   169,   158,   458,   456,
     228,   228,   424,   228,   161,   161,   161,   161,   478,   478,
       4,    38,    39,   162,   416,   417,   418,   419,   414,   374,
     478,   368,   368,   228,    21,   151,   161,   403,   162,     4,
     398,   459,   163,   474,   162,     4,    83,   464,   465,    62,
      63,   281,   478,   281,   246,   309,   478,    62,    63,   296,
     299,   303,   310,   159,   159,    62,    63,   306,   307,   309,
     165,   163,   290,   309,   163,   250,   393,     4,   361,   362,
     381,   340,   161,   161,   161,   161,   162,   226,   478,   163,
     430,   162,     4,   231,   425,   162,   162,   457,   163,   478,
     478,   478,   100,   478,   100,   478,   100,   478,   162,   478,
     162,   158,   201,   418,   163,   158,   163,   163,   369,   370,
     371,   162,    22,    62,    63,   151,   407,   408,   478,   426,
     161,   201,   462,   469,   464,   159,   163,   478,   162,   478,
     162,   165,   299,   303,   151,   149,   150,   158,   300,   302,
     161,   294,   309,   294,   310,   310,    80,   158,   162,   308,
     247,     4,   383,   384,   385,   387,   158,   163,   384,   390,
     391,   392,   100,   478,   100,   478,   100,   478,   478,   470,
     158,   162,   165,   442,   436,   159,   245,   163,   434,   435,
     478,   162,   478,   162,   478,   162,   163,   162,   438,   417,
     162,     4,   158,   365,   159,   478,   478,   162,    64,   158,
     162,   162,   478,   162,    55,   472,   475,   476,   159,   478,
     478,    79,   279,     9,   478,   151,   159,   302,   144,   303,
     158,   302,   159,   309,   478,   158,   295,   306,   306,   163,
     167,    99,   243,   158,   163,   362,   158,   163,   161,   478,
     162,   478,   162,   478,   162,   162,   449,   226,   478,    55,
     426,   426,   478,     4,   478,   426,   426,   162,   163,   162,
     163,   162,   163,   163,   441,   370,   163,   478,   408,   408,
     162,   409,    57,   477,   463,   478,   468,   478,   158,   161,
     280,   478,   165,   144,   144,   301,   304,   310,   303,   144,
     295,   165,   309,   388,   384,   391,   396,   162,   163,   162,
     163,   162,   163,   163,    69,   450,   451,   162,   409,   437,
     159,   432,   163,   163,   163,    85,    86,   445,   475,   163,
     281,   478,   162,   478,   161,   161,   158,   162,   304,   162,
     478,   295,   161,   162,   163,   163,   163,     8,    70,   453,
     454,   478,    57,   443,   478,   163,    69,   446,   447,   178,
     422,   478,    91,    92,   165,   159,   301,   304,   304,   162,
     165,   396,   452,   158,   165,   444,   422,   453,   162,   279,
     478,   478,   478,   161,   282,   283,   478,    91,   302,    91,
     302,   478,   162,   475,   478,   426,   162,   448,   475,   158,
     162,   162,   162,   283,   478,   163,   165,   309,   165,   309,
     165,   433,   426,   283,   158,   165,   478,   162,   309,   162,
     309,   426,   158,   277,   283,   478,   165,   162,   162,   162,
     162,   283,   162,   158,   162,   165,   478,   162,   162,   163,
     283,   478,   158,   162,   283,   158,   283,   158,   283,   158,
     162,   283,   158,   283,   158,   283,   158,   283,   158,   283,
     158,   283,   162
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   174,   176,   175,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   179,   178,   180,   180,   182,   183,
     181,   184,   184,   185,   185,   186,   186,   187,   187,   187,
     188,   188,   188,   190,   191,   189,   193,   194,   192,   192,
     195,   195,   196,   197,   196,   198,   196,   196,   199,   199,
     199,   200,   200,   201,   201,   202,   202,   204,   203,   205,
     206,   203,   207,   203,   203,   209,   210,   208,   211,   211,
     212,   212,   212,   212,   214,   215,   213,   216,   216,   217,
     217,   217,   217,   217,   217,   217,   217,   217,   219,   220,
     221,   218,   222,   223,   223,   224,   224,   225,   226,   226,
     227,   227,   227,   227,   227,   227,   227,   227,   228,   228,
     230,   229,   232,   231,   233,   233,   234,   234,   234,   235,
     235,   235,   236,   236,   236,   236,   237,   237,   238,   238,
     238,   238,   238,   238,   238,   238,   239,   239,   239,   240,
     240,   240,   241,   241,   241,   241,   241,   242,   242,   243,
     243,   243,   243,   244,   244,   245,   245,   246,   246,   247,
     247,   247,   247,   247,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   250,   249,   252,   251,   253,   251,   254,
     251,   255,   251,   256,   251,   257,   251,   258,   258,   258,
     258,   259,   259,   259,   260,   260,   260,   261,   261,   261,
     262,   262,   263,   263,   264,   264,   264,   264,   265,   265,
     266,   266,   267,   268,   266,   269,   269,   271,   270,   272,
     270,   273,   273,   274,   275,   275,   276,   276,   277,   277,
     278,   278,   279,   279,   280,   280,   280,   280,   281,   281,
     281,   282,   282,   282,   282,   282,   283,   283,   284,   284,
     285,   285,   286,   286,   286,   287,   287,   288,   289,   289,
     290,   291,   291,   292,   293,   293,   294,   294,   294,   295,
     295,   296,   296,   297,   297,   297,   298,   298,   298,   299,
     299,   300,   300,   301,   301,   302,   302,   302,   303,   304,
     305,   306,   306,   306,   307,   307,   307,   308,   309,   309,
     311,   310,   312,   312,   312,   313,   314,   315,   316,   317,
     317,   318,   319,   319,   319,   319,   319,   321,   320,   323,
     322,   324,   324,   325,   325,   326,   327,   328,   328,   329,
     331,   330,   332,   332,   332,   333,   334,   334,   335,   335,
     335,   336,   336,   337,   338,   338,   339,   339,   340,   341,
     343,   342,   345,   344,   346,   346,   347,   348,   348,   349,
     349,   349,   350,   350,   351,   352,   352,   354,   353,   356,
     355,   357,   358,   359,   357,   360,   360,   360,   361,   361,
     362,   364,   365,   363,   366,   363,   367,   363,   368,   368,
     369,   369,   370,   370,   371,   372,   373,   373,   374,   375,
     375,   376,   376,   377,   377,   377,   378,   378,   380,   379,
     381,   379,   382,   382,   383,   383,   384,   384,   386,   385,
     388,   387,   389,   389,   390,   390,   391,   392,   391,   393,
     393,   394,   394,   395,   395,   395,   395,   396,   397,   397,
     398,   398,   398,   398,   398,   398,   399,   399,   400,   400,
     402,   403,   401,   404,   401,   405,   401,   406,   406,   406,
     406,   406,   406,   407,   407,   407,   408,   408,   408,   409,
     409,   410,   410,   411,   411,   411,   413,   414,   412,   415,
     415,   416,   416,   417,   417,   418,   419,   419,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   421,   421,   421,
     421,   421,   421,   421,   422,   422,   422,   422,   422,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   424,   424,   425,   425,   425,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   427,   426,   428,   426,   429,
     430,   426,   431,   432,   433,   426,   434,   426,   435,   426,
     436,   437,   426,   438,   426,   439,   439,   439,   439,   440,
     440,   440,   441,   441,   441,   442,   442,   444,   443,   443,
     445,   445,   447,   448,   446,   449,   449,   451,   452,   450,
     453,   453,   454,   454,   454,   454,   455,   455,   455,   456,
     456,   457,   457,   458,   458,   459,   459,   460,   460,   461,
     462,   462,   462,   463,   463,   463,   464,   465,   465,   465,
     467,   468,   466,   469,   466,   470,   466,   471,   466,   473,
     474,   472,   476,   475,   475,   477,   477,   478,   478,   478,
     478,   479,   479,   479,   479,   479,   479,   480,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   481,   481,   482,
     482,   482,   482
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     0,     2,     4,     0,     0,     0,
       5,     1,     0,     1,     3,     1,     3,     1,     3,     3,
       1,     1,     3,     0,     0,    11,     0,     0,     6,     0,
       1,     3,     0,     0,     5,     0,     5,     1,     2,     0,
       4,     1,     3,     1,     0,     2,     0,     0,     3,     0,
       0,     5,     0,     6,     3,     0,     0,     9,     2,     0,
       1,     1,     1,     1,     0,     0,     9,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     0,
       0,     9,     2,     2,     0,     1,     3,     1,     1,     5,
       2,     2,     2,     2,     4,     4,     6,     8,     1,     0,
       0,     5,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     0,     1,     0,     1,     2,
       1,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       5,     5,     3,     2,     2,     1,     0,     1,     1,     2,
       2,     2,     2,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     0,     6,     0,     7,     0,     9,     0,
      11,     0,     9,     0,    10,     0,    10,     1,     2,     3,
       2,     0,     1,     1,     0,     1,     1,     0,     1,     1,
       2,     1,     3,     0,     3,     2,     1,     0,     1,     0,
       2,     0,     0,     0,     6,     1,     3,     0,     5,     0,
       2,     2,     0,     3,     2,     0,    10,    14,     2,     0,
       4,     0,     2,     0,     1,     5,     5,     5,     1,     1,
       0,     1,     5,     7,    13,    25,     1,     5,     3,     2,
       2,     1,     1,     1,     1,     3,     4,     5,     1,     3,
       3,     4,     0,     2,     4,     4,     4,     1,     2,     2,
       3,     1,     1,     7,    12,    11,     6,    12,    11,     2,
       3,     2,     3,     1,     3,     1,     1,     0,     1,     1,
       5,     2,     2,     1,     1,     3,     3,     1,     1,     5,
       0,     3,     1,     1,     0,     1,     1,     1,     2,     2,
       3,     2,     1,     1,     1,     1,     1,     0,     6,     0,
       6,     1,     3,     3,     1,     1,     3,     1,     3,     4,
       0,     7,     2,     3,     0,     1,     1,     1,     1,     1,
       0,     1,     3,     2,     2,     0,     1,     3,     1,     3,
       0,     5,     0,     3,     1,     1,     4,     2,     0,     1,
       1,     0,     1,     2,     3,     1,     3,     0,     3,     0,
       2,     2,     0,     0,     4,     2,     2,     1,     1,     3,
       1,     0,     0,     8,     0,     6,     0,     6,     0,     3,
       1,     3,     1,     3,     2,     4,     1,     3,     3,     1,
       1,     6,     4,     1,     2,     2,     1,     1,     0,     6,
       0,     6,     1,     1,     1,     3,     1,     1,     0,     5,
       0,     6,     1,     3,     1,     3,     1,     0,     4,     4,
       0,     1,     3,     0,     1,     4,     5,     1,     1,     3,
       1,     2,     6,     5,     3,     2,     1,     1,     1,     1,
       0,     0,     6,     0,     4,     0,     4,     4,     4,     3,
       3,     2,     0,     1,     3,     3,     2,     2,     1,     2,
       0,     2,     0,     1,     1,     0,     0,     0,     6,     2,
       4,     1,     3,     2,     1,     1,     1,     1,     7,     7,
       8,     8,     7,     6,     3,     7,     8,     7,     7,     8,
       8,     7,     7,     8,     5,     4,     4,     5,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     5,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     0,     5,     0,     5,     0,
       0,     8,     0,     0,     0,    13,     0,     7,     0,     7,
       0,     0,     9,     0,     9,     1,     2,     2,     2,     1,
       1,     1,     2,     2,     0,     2,     0,     0,     3,     0,
       2,     0,     0,     0,     4,     2,     0,     0,     0,     4,
       2,     1,     1,     1,     1,     3,     6,     2,     2,     1,
       3,     1,     3,     4,     0,     1,     0,     1,     3,     1,
       2,     2,     0,     1,     1,     2,     1,     2,     4,     3,
       0,     0,    11,     0,     7,     0,     7,     0,     4,     0,
       0,     7,     0,     2,     1,     2,     0,     1,     6,     3,
       2,     1,     4,     2,     1,     1,     1,     0,     7,     5,
       5,     3,     7,     3,     6,     3,     4,     4,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     3,     3,     4,     4,
       3,     5,     5,     5,     5,     5,     5,     1,     3,     1,
       1,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      YY_LAC_DISCARD ("YYBACKUP");                              \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if FRONTEND_VERILOG_YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !FRONTEND_VERILOG_YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !FRONTEND_VERILOG_YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return 1 if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYSIZE_T *yycapacity, YYSIZE_T yyadd,
#if FRONTEND_VERILOG_YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yytype_int16 **yybottom,
                      yytype_int16 *yybottom_no_free,
                      yytype_int16 **yytop, yytype_int16 *yytop_empty)
{
  YYSIZE_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYSIZE_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYSIZE_T yyalloc = 2 * yysize_new;
      yytype_int16 *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return 1;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        (yytype_int16*) YYSTACK_ALLOC (yyalloc * sizeof *yybottom_new);
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return 1;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                         \
do {                                                             \
  if (!yy_lac_established)                                       \
    {                                                            \
      YYDPRINTF ((stderr,                                        \
                  "LAC: initial context established for %s\n",   \
                  yytname[yytoken]));                            \
      yy_lac_established = 1;                                    \
      {                                                          \
        int yy_lac_status =                                      \
          yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken); \
        if (yy_lac_status == 2)                                  \
          goto yyexhaustedlab;                                   \
        if (yy_lac_status == 1)                                  \
          goto yyerrlab;                                         \
      }                                                          \
    }                                                            \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if FRONTEND_VERILOG_YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      if (yydebug)                                                       \
        YYFPRINTF (stderr, "LAC: initial context discarded due to "      \
                   Event "\n");                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return 2 if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yytype_int16 *yyesa, yytype_int16 **yyes,
        YYSIZE_T *yyes_capacity, yytype_int16 *yyssp, int yytoken)
{
  yytype_int16 *yyes_prev = yyssp;
  yytype_int16 *yyesp = yyes_prev;
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yytname[yytoken]));
  if (yytoken == YYUNDEFTOK)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          yyrule = yydefact[*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      {
        YYSIZE_T yylen = yyr2[yyrule];
        YYDPRINTF ((stderr, " R%d", yyrule - 1));
        if (yyesp != yyes_prev)
          {
            YYSIZE_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yylen -= yysize;
                yyesp = yyes_prev;
              }
          }
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      {
        int yystate;
        {
          int yylhs = yyr1[yyrule] - YYNTOKENS;
          yystate = yypgoto[yylhs] + *yyesp;
          if (yystate < 0 || YYLAST < yystate
              || yycheck[yystate] != *yyesp)
            yystate = yydefgoto[yylhs];
          else
            yystate = yytable[yystate];
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            *yyesp = yystate;
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if FRONTEND_VERILOG_YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return 2;
              }
            *++yyesp = yystate;
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store or if
   yy_lac returned 2.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyesa, yytype_int16 **yyes,
                YYSIZE_T *yyes_capacity, yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          int yyx;

          for (yyx = 0; yyx < YYNTOKENS; ++yyx)
            if (yyx != YYTERROR && yyx != YYUNDEFTOK)
              {
                {
                  int yy_lac_status = yy_lac (yyesa, yyes, yyes_capacity,
                                              yyssp, yyx);
                  if (yy_lac_status == 2)
                    return 2;
                  if (yy_lac_status == 1)
                    continue;
                }
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
# if FRONTEND_VERILOG_YYDEBUG
      else if (yydebug)
        YYFPRINTF (stderr, "No expected tokens.\n");
# endif
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

    yytype_int16 yyesa[20];
    yytype_int16 *yyes;
    YYSIZE_T yyes_capacity;

  int yy_lac_established = 0;
  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  yyes = yyesa;
  yyes_capacity = sizeof yyesa / sizeof *yyes;
  if (YYMAXDEPTH < yyes_capacity)
    yyes_capacity = YYMAXDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
          case 2:
#line 466 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	ast_stack.clear();
	ast_stack.push_back(current_ast);
}
#line 3598 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 469 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	ast_stack.pop_back();
	log_assert(GetSize(ast_stack) == 0);
	for (auto &it : default_attr_list)
		delete it.second;
	default_attr_list.clear();
}
#line 3610 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 490 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			(*attr_list)[it.first] = it.second->clone();
	}
#line 3622 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 496 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.al) = attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3635 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 506 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc));
	}
#line 3643 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 512 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			delete it.second;
		default_attr_list.clear();
	}
#line 3656 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 519 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		attr_list->swap(default_attr_list);
		delete attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3670 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 537 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (attr_list->count(*(yyvsp[0].string)) != 0)
			delete (*attr_list)[*(yyvsp[0].string)];
		(*attr_list)[*(yyvsp[0].string)] = AstNode::mkconst_int(1, false);
		delete (yyvsp[0].string);
	}
#line 3681 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 543 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (attr_list->count(*(yyvsp[-2].string)) != 0)
			delete (*attr_list)[*(yyvsp[-2].string)];
		(*attr_list)[*(yyvsp[-2].string)] = (yyvsp[0].ast);
		delete (yyvsp[-2].string);
	}
#line 3692 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 551 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = (yyvsp[0].string);
	}
#line 3700 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 554 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "::" + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "::" + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3713 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 562 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "." + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "." + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3726 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 574 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[-1].string); }
#line 3732 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 578 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		enterTypeScope();
	}
#line 3740 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 580 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		do_not_require_port_stubs = false;
		AstNode *mod = new AstNode(AST_MODULE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		port_stubs.clear();
		port_counter = 0;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 3756 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 590 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
					port_stubs.begin()->first.c_str());
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-9]), (yyloc));
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		checkLabelsMatch("Module name", (yyvsp[-7].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-7].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 3774 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 605 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1 = nullptr; }
#line 3780 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 605 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { if (astbuf1) delete astbuf1; }
#line 3786 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 612 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 3797 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 618 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 3808 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 636 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			if (ast_stack.back()->children.back()->is_input) {
				AstNode *n = ast_stack.back()->children.back();
				if (n->attributes.count(ID::defaultvalue))
					delete n->attributes.at(ID::defaultvalue);
				n->attributes[ID::defaultvalue] = (yyvsp[0].ast);
			} else {
				AstNode *wire = new AstNode(AST_IDENTIFIER);
				wire->str = ast_stack.back()->children.back()->str;
				if (ast_stack.back()->children.back()->is_reg || ast_stack.back()->children.back()->is_logic)
					ast_stack.back()->children.push_back(new AstNode(AST_INITIAL, new AstNode(AST_BLOCK, new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast)))));
				else
					ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast)));
			}
		} else
			frontend_verilog_yyerror("SystemVerilog interface in module port list cannot have a default value.");
	}
#line 3831 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 657 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			AstNode *node = ast_stack.back()->children.back()->clone();
			node->str = *(yyvsp[0].string);
			node->port_id = ++port_counter;
			ast_stack.back()->children.push_back(node);
			SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		} else {
			if (port_stubs.count(*(yyvsp[0].string)) != 0)
				frontend_verilog_yyerror("Duplicate module port `%s'.", (yyvsp[0].string)->c_str());
			port_stubs[*(yyvsp[0].string)] = ++port_counter;
		}
		delete (yyvsp[0].string);
	}
#line 3850 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 671 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = new AstNode(AST_INTERFACEPORT);
		astbuf1->children.push_back(new AstNode(AST_INTERFACEPORTTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 3861 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 676 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {  /* SV interfaces */
		if (!sv_mode)
			frontend_verilog_yyerror("Interface found in port list (%s). This is not supported unless read_verilog is called with -sv!", (yyvsp[0].string)->c_str());
		astbuf2 = astbuf1->clone(); // really only needed if multiple instances of same type.
		astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		astbuf2->port_id = ++port_counter;
		ast_stack.back()->children.push_back(astbuf2);
		delete astbuf1; // really only needed if multiple instances of same type.
	}
#line 3876 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 686 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = (yyvsp[-2].ast);
		node->str = *(yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->port_id = ++port_counter;
		AstNode *range = checkRange(node, (yyvsp[-1].ast));
		if (range != NULL)
			node->children.push_back(range);
		if (!node->is_input && !node->is_output)
			frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[0].string)->c_str());
		if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
			frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[0].string)->c_str());
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		delete (yyvsp[0].string);
	}
#line 3897 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 702 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		do_not_require_port_stubs = true;
	}
#line 3905 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 707 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		enterTypeScope();
	}
#line 3913 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 709 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *mod = new AstNode(AST_PACKAGE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 3926 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 716 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.pop_back();
		checkLabelsMatch("Package name", (yyvsp[-5].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-5].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 3939 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 732 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		enterTypeScope();
	}
#line 3947 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 734 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		do_not_require_port_stubs = false;
		AstNode *intf = new AstNode(AST_INTERFACE);
		ast_stack.back()->children.push_back(intf);
		ast_stack.push_back(intf);
		current_ast_mod = intf;
		port_stubs.clear();
		port_counter = 0;
		intf->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 3963 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 744 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
				port_stubs.begin()->first.c_str());
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 3977 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 762 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *bnode = new AstNode(AST_BIND);
		ast_stack.back()->children.push_back(bnode);
		ast_stack.push_back(bnode);
	}
#line 3987 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 767 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// bind_target should have added at least one child
		log_assert(ast_stack.back()->children.size() >= 1);
	}
#line 3996 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 771 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// The single_cell parser in cell_list_no_array uses astbuf1 as
		// a sort of template for constructing cells.
		astbuf1 = new AstNode(AST_CELL);
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4009 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 779 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// cell_list should have added at least one more child
		log_assert(ast_stack.back()->children.size() >= 2);
		delete astbuf1;
		ast_stack.pop_back();
	}
#line 4020 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 814 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		auto *node = new AstNode(AST_IDENTIFIER);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
	}
#line 4031 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 822 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].ast); }
#line 4037 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 823 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[-4].ast); delete (yyvsp[-2].ast); delete (yyvsp[0].ast); }
#line 4043 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 826 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].string); }
#line 4049 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 827 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].string); }
#line 4055 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 828 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].string); }
#line 4061 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 840 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4067 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 842 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-3]), (yyloc)); }
#line 4073 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 845 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4079 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 847 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc)); }
#line 4085 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 854 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_input = true;
	}
#line 4093 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 857 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_output = true;
	}
#line 4101 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 860 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_input = true;
		astbuf3->is_output = true;
	}
#line 4110 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 866 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf3->is_signed = true;  }
#line 4116 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 867 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf3->is_signed = false; }
#line 4122 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 871 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	    current_wire_rand = true;
	    current_wire_const = true;
	}
#line 4131 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 875 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	    current_wire_const = true;
	}
#line 4139 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 878 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	    current_wire_rand = true;
	}
#line 4147 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 888 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	}
#line 4154 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 890 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	}
#line 4161 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 893 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_reg = true;
	}
#line 4169 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 896 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_reg = true;
	}
#line 4177 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 900 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_logic = true;
	}
#line 4185 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 903 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_logic = true;
	}
#line 4193 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 906 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_logic = true;
	}
#line 4201 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 909 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->type = AST_GENVAR;
		astbuf3->is_reg = true;
		astbuf3->is_signed = true;
		astbuf3->range_left = 31;
		astbuf3->range_right = 0;
	}
#line 4213 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 918 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_wor = true;
	}
#line 4221 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 921 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->is_wand = true;
	}
#line 4229 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 927 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
	}
#line 4236 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 929 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf3->range_left = (yyvsp[0].integer) - 1;
		astbuf3->range_right = 0;
		astbuf3->is_signed = true;
	}
#line 4246 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 934 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addWiretypeNode((yyvsp[0].string), astbuf3);
	}
#line 4254 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 939 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 32; }
#line 4260 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 940 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 32; }
#line 4266 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 941 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 16; }
#line 4272 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 942 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 64; }
#line 4278 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 943 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) =  8; }
#line 4284 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 946 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = TOK_LOGIC; }
#line 4290 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 947 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.integer) = TOK_REG; }
#line 4296 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 950 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-3].ast));
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4306 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 955 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), (yyvsp[-1].ast)), AstNode::mkconst_int(1, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
	}
#line 4317 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 961 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), AstNode::mkconst_int(1, true)), (yyvsp[-1].ast)));
	}
#line 4328 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 967 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4337 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 973 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_MULTIRANGE, (yyvsp[-1].ast), (yyvsp[0].ast));
	}
#line 4345 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 976 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[-1].ast);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 4354 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 982 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4362 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 985 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = NULL;
	}
#line 4370 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 990 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = (yyvsp[0].ast); }
#line 4376 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 991 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = (yyvsp[0].ast); }
#line 4382 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1007 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = *(yyvsp[-1].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 4393 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1012 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete (yyvsp[-4].string);
		ast_stack.pop_back();
	}
#line 4402 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1018 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[0].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4415 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1025 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
	}
#line 4423 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1028 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-3].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-5].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4437 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1036 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
	}
#line 4445 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1039 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-5].string) + ":" + RTLIL::unescape_id(*(yyvsp[-3].string))));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-7].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-5].string);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4460 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1048 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
	}
#line 4468 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1051 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = new AstNode(AST_TASK);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4482 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1059 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4491 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1063 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// The difference between void functions and tasks is that
		// always_comb's implicit sensitivity list behaves as if functions were
		// inlined, but ignores signals read only in tasks. This only matters
		// for event based simulation, and for synthesis we can treat a void
		// function like a task.
		current_function_or_task = new AstNode(AST_TASK);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-4].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4510 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1076 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4519 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1080 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = new AstNode(AST_FUNCTION);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-4].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		AstNode *outreg = new AstNode(AST_WIRE);
		outreg->str = *(yyvsp[0].string);
		outreg->is_signed = false;
		outreg->is_reg = true;
		if ((yyvsp[-1].ast) != NULL) {
			outreg->children.push_back((yyvsp[-1].ast));
			outreg->is_signed = (yyvsp[-1].ast)->is_signed;
			(yyvsp[-1].ast)->is_signed = false;
			outreg->is_custom_type = (yyvsp[-1].ast)->type == AST_WIRETYPE;
		}
		current_function_or_task->children.push_back(outreg);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4544 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1099 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4553 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1105 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_WIRETYPE);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4563 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1110 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = makeRange(0, 0, (yyvsp[0].boolean));
	}
#line 4571 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1113 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->is_signed = (yyvsp[-1].boolean);
	}
#line 4580 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1117 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = makeRange((yyvsp[-1].integer) - 1, 0, (yyvsp[0].boolean));
	}
#line 4588 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1128 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 4594 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1129 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 4600 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1130 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 4606 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1133 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 4612 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1134 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 4618 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1135 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 4624 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1139 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[-1].string)));
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4634 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1144 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[0].string)));
		delete (yyvsp[0].string);
	}
#line 4643 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1164 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		albuf = nullptr;
		astbuf1 = nullptr;
		astbuf2 = nullptr;
	}
#line 4653 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1168 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 4664 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1179 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		bool prev_was_input = true;
		bool prev_was_output = false;
		if (albuf) {
			prev_was_input = astbuf1->is_input;
			prev_was_output = astbuf1->is_output;
			delete astbuf1;
			if (astbuf2 != NULL)
				delete astbuf2;
			free_attr(albuf);
		}
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
		if (!astbuf1->is_input && !astbuf1->is_output) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			astbuf1->is_input = prev_was_input;
			astbuf1->is_output = prev_was_output;
		}
	}
#line 4690 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1200 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!astbuf1) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			albuf = new dict<IdString, AstNode*>;
			astbuf1 = new AstNode(AST_WIRE);
			current_wire_rand = false;
			current_wire_const = false;
			astbuf1->is_input = true;
			astbuf2 = NULL;
		}
	}
#line 4707 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1227 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *en_expr = (yyvsp[-9].ast);
		char specify_edge = (yyvsp[-7].ch);
		AstNode *src_expr = (yyvsp[-6].ast);
		string *oper = (yyvsp[-5].string);
		specify_target *target = (yyvsp[-4].specify_target_ptr);
		specify_rise_fall *timing = (yyvsp[-1].specify_rise_fall_ptr);

		if (specify_edge != 0 && target->dat == nullptr)
			frontend_verilog_yyerror("Found specify edge but no data spec.\n");

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = target->dat ? "$specify3" : "$specify2";
		SET_AST_NODE_LOC(cell, en_expr ? (yylsp[-9]) : (yylsp[-8]), (yylsp[0]));

		char oper_polarity = 0;
		char oper_type = oper->at(0);

		if (oper->size() == 3) {
			oper_polarity = oper->at(0);
			oper_type = oper->at(1);
		}

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_type == '*', false, 1)));
		cell->children.back()->str = "\\FULL";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity != 0, false, 1)));
		cell->children.back()->str = "\\SRC_DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity == '+', false, 1)));
		cell->children.back()->str = "\\SRC_DST_POL";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_min));
		cell->children.back()->str = "\\T_RISE_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_avg));
		cell->children.back()->str = "\\T_RISE_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_max));
		cell->children.back()->str = "\\T_RISE_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_min));
		cell->children.back()->str = "\\T_FALL_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_avg));
		cell->children.back()->str = "\\T_FALL_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_max));
		cell->children.back()->str = "\\T_FALL_MAX";

		cell->children.push_back(new AstNode(AST_ARGUMENT, en_expr ? en_expr : AstNode::mkconst_int(1, false, 1)));
		cell->children.back()->str = "\\EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, target->dst));
		cell->children.back()->str = "\\DST";

		if (target->dat)
		{
			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge != 0, false, 1)));
			cell->children.back()->str = "\\EDGE_EN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge == 'p', false, 1)));
			cell->children.back()->str = "\\EDGE_POL";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op != 0, false, 1)));
			cell->children.back()->str = "\\DAT_DST_PEN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op == '+', false, 1)));
			cell->children.back()->str = "\\DAT_DST_POL";

			cell->children.push_back(new AstNode(AST_ARGUMENT, target->dat));
			cell->children.back()->str = "\\DAT";
		}

		delete oper;
		delete target;
		delete timing;
	}
#line 4796 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1311 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (*(yyvsp[-13].string) != "$setup" && *(yyvsp[-13].string) != "$hold" && *(yyvsp[-13].string) != "$setuphold" && *(yyvsp[-13].string) != "$removal" && *(yyvsp[-13].string) != "$recovery" &&
				*(yyvsp[-13].string) != "$recrem" && *(yyvsp[-13].string) != "$skew" && *(yyvsp[-13].string) != "$timeskew" && *(yyvsp[-13].string) != "$fullskew" && *(yyvsp[-13].string) != "$nochange")
			frontend_verilog_yyerror("Unsupported specify rule type: %s\n", (yyvsp[-13].string)->c_str());

		AstNode *src_pen = AstNode::mkconst_int((yyvsp[-11].ch) != 0, false, 1);
		AstNode *src_pol = AstNode::mkconst_int((yyvsp[-11].ch) == 'p', false, 1);
		AstNode *src_expr = (yyvsp[-10].ast), *src_en = (yyvsp[-9].ast) ? (yyvsp[-9].ast) : AstNode::mkconst_int(1, false, 1);

		AstNode *dst_pen = AstNode::mkconst_int((yyvsp[-7].ch) != 0, false, 1);
		AstNode *dst_pol = AstNode::mkconst_int((yyvsp[-7].ch) == 'p', false, 1);
		AstNode *dst_expr = (yyvsp[-6].ast), *dst_en = (yyvsp[-5].ast) ? (yyvsp[-5].ast) : AstNode::mkconst_int(1, false, 1);

		specify_triple *limit = (yyvsp[-3].specify_triple_ptr);
		specify_triple *limit2 = (yyvsp[-2].specify_triple_ptr);

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = "$specrule";
		SET_AST_NODE_LOC(cell, (yylsp[-13]), (yylsp[0]));

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_str(*(yyvsp[-13].string))));
		cell->children.back()->str = "\\TYPE";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_min));
		cell->children.back()->str = "\\T_LIMIT_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_avg));
		cell->children.back()->str = "\\T_LIMIT_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_max));
		cell->children.back()->str = "\\T_LIMIT_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_min : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_avg : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_max : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, src_pen));
		cell->children.back()->str = "\\SRC_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, src_pol));
		cell->children.back()->str = "\\SRC_POL";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pen));
		cell->children.back()->str = "\\DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pol));
		cell->children.back()->str = "\\DST_POL";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_en));
		cell->children.back()->str = "\\SRC_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_en));
		cell->children.back()->str = "\\DST_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_expr));
		cell->children.back()->str = "\\DST";

		delete (yyvsp[-13].string);
		delete limit;
		delete limit2;
	}
#line 4873 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1385 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_triple_ptr) = (yyvsp[0].specify_triple_ptr);
	}
#line 4881 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1388 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_triple_ptr) = nullptr;
	}
#line 4889 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1393 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 4897 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1396 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = nullptr;
	}
#line 4905 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1401 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4913 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1404 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = nullptr;
	}
#line 4921 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1409 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[0].ast);
		(yyval.specify_target_ptr)->dat = nullptr;
	}
#line 4932 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1415 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4943 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1421 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '-';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4954 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1427 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '+';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4965 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1435 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ch) = 'p'; }
#line 4971 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1436 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ch) = 'n'; }
#line 4977 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1437 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ch) = 0; }
#line 4983 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1440 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[0].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall.t_min = (yyvsp[0].specify_triple_ptr)->t_min->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_avg = (yyvsp[0].specify_triple_ptr)->t_avg->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_max = (yyvsp[0].specify_triple_ptr)->t_max->clone();
		delete (yyvsp[0].specify_triple_ptr);
	}
#line 4996 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1448 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-3].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-1].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
	}
#line 5008 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1455 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-5].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5022 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1464 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-11].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5039 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1476 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-23].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-23].specify_triple_ptr);
		delete (yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-19].specify_triple_ptr);
		delete (yyvsp[-17].specify_triple_ptr);
		delete (yyvsp[-15].specify_triple_ptr);
		delete (yyvsp[-13].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5062 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1496 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[0].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[0].ast)->clone();
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast)->clone();
	}
#line 5073 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1502 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[-4].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[-2].ast);
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast);
	}
#line 5084 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 307:
#line 1623 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].ast); }
#line 5090 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 308:
#line 1626 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].ast); }
#line 5096 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 309:
#line 1627 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete (yyvsp[-4].ast);
		delete (yyvsp[-2].ast);
		delete (yyvsp[0].ast);
	}
#line 5106 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 310:
#line 1634 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].string); }
#line 5112 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 311:
#line 1635 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[0].ast); }
#line 5118 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 312:
#line 1640 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->is_signed = true;
	}
#line 5126 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 313:
#line 1642 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->is_signed = false;
	}
#line 5134 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 315:
#line 1647 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->is_reg = false;
	}
#line 5142 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 316:
#line 1652 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->children.push_back(new AstNode(AST_REALVALUE));
	}
#line 5150 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 317:
#line 1657 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ast) != NULL) {
			astbuf1->children.push_back((yyvsp[0].ast));
		}
	}
#line 5160 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 319:
#line 1665 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addRange(astbuf1, 0, 0);
	}
#line 5168 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 320:
#line 1668 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->children.push_back((yyvsp[0].ast));
	}
#line 5176 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 326:
#line 1675 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addWiretypeNode((yyvsp[0].string), astbuf1);
	}
#line 5184 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 327:
#line 1680 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5194 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 328:
#line 1684 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
	}
#line 5202 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 329:
#line 1689 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5212 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 330:
#line 1693 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
	}
#line 5220 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 333:
#line 1701 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *decl = ast_stack.back()->children.back();
		log_assert(decl->type == AST_PARAMETER || decl->type == AST_LOCALPARAM);
		delete decl->children[0];
		decl->children[0] = (yyvsp[0].ast);
	}
#line 5231 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 334:
#line 1707 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *decl = ast_stack.back()->children.back();
		if (decl->type != AST_PARAMETER) {
			log_assert(decl->type == AST_LOCALPARAM);
			frontend_verilog_yyerror("localparam initialization is missing!");
		}
		if (!sv_mode)
			frontend_verilog_yyerror("Parameter defaults can only be omitted in SystemVerilog mode!");
		delete decl->children[0];
		decl->children.erase(decl->children.begin());
	}
#line 5247 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 335:
#line 1720 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node;
		if (astbuf1 == nullptr) {
			if (!sv_mode)
				frontend_verilog_yyerror("In pure Verilog (not SystemVerilog), parameter/localparam with an initializer must use the parameter/localparam keyword");
			node = new AstNode(AST_PARAMETER);
			node->children.push_back(AstNode::mkconst_int(0, true));
		} else {
			node = astbuf1->clone();
		}
		node->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
	}
#line 5267 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 339:
#line 1743 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_DEFPARAM);
		node->children.push_back((yyvsp[-2].ast));
		node->children.push_back((yyvsp[0].ast));
		if ((yyvsp[-3].ast) != NULL)
			node->children.push_back((yyvsp[-3].ast));
		ast_stack.back()->children.push_back(node);
	}
#line 5280 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 340:
#line 1756 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		static int enum_count;
		// create parent node for the enum
		astbuf2 = new AstNode(AST_ENUM);
		ast_stack.back()->children.push_back(astbuf2);
		astbuf2->str = std::string("$enum");
		astbuf2->str += std::to_string(enum_count++);
		// create the template for the names
		astbuf1 = new AstNode(AST_ENUM_ITEM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
	}
#line 5296 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 341:
#line 1766 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// create template for the enum vars
		auto tnode = astbuf1->clone();
		delete astbuf1;
		astbuf1 = tnode;
		tnode->type = AST_WIRE;
		tnode->attributes[ID::enum_type] = AstNode::mkconst_str(astbuf2->str);
		// drop constant but keep any range
		delete tnode->children[0];
		tnode->children.erase(tnode->children.begin());
		(yyval.ast) = astbuf1;
	}
#line 5313 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 343:
#line 1780 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5319 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 344:
#line 1781 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1->is_reg = true; addRange(astbuf1); }
#line 5325 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 345:
#line 1785 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1->is_reg = true;
		astbuf1->is_signed = true;
		addRange(astbuf1, (yyvsp[0].integer) - 1, 0);
	}
#line 5335 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 346:
#line 1791 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1->is_reg   = true; }
#line 5341 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 347:
#line 1792 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1->is_logic = true; }
#line 5347 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 348:
#line 1796 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1->is_signed = true; }
#line 5353 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 349:
#line 1797 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1->is_signed = false; }
#line 5359 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 353:
#line 1806 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// put in fn
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		delete node->children[0];
		node->children[0] = (yyvsp[0].ast) ? (yyvsp[0].ast) : new AstNode(AST_NONE);
		astbuf2->children.push_back(node);
	}
#line 5376 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 354:
#line 1821 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = (yyvsp[0].ast); }
#line 5382 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 355:
#line 1822 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = NULL; }
#line 5388 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 358:
#line 1830 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		ast_stack.back()->children.push_back(node);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->is_enum = true;
	}
#line 5403 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 359:
#line 1842 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete (yyvsp[-2].ast); }
#line 5409 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 360:
#line 1850 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		append_attr((yyvsp[0].ast), (yyvsp[-1].al));
	}
#line 5417 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 361:
#line 1852 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf2;
	}
#line 5425 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 362:
#line 1857 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf2 = (yyvsp[0].ast); }
#line 5431 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 363:
#line 1857 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = astbuf2; }
#line 5437 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 364:
#line 1861 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = new AstNode(AST_STRUCT); }
#line 5443 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 365:
#line 1862 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast) = new AstNode(AST_UNION); }
#line 5449 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 368:
#line 1870 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { frontend_verilog_yyerror("Only PACKED supported at this time"); }
#line 5455 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 369:
#line 1873 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf2->is_signed = true; }
#line 5461 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 370:
#line 1874 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf2->is_signed = false; }
#line 5467 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 374:
#line 1882 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { delete astbuf1; }
#line 5473 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 377:
#line 1890 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
			astbuf1->str = (yyvsp[0].string)->substr(1);
			delete (yyvsp[0].string);
			astbuf3 = astbuf1->clone();
			SET_AST_NODE_LOC(astbuf3, (yylsp[0]), (yylsp[0]));
			astbuf2->children.push_back(astbuf3);
		}
#line 5485 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 378:
#line 1896 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].ast)) astbuf3->children.push_back((yyvsp[0].ast)); }
#line 5491 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 379:
#line 1899 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { astbuf1 = new AstNode(AST_STRUCT_ITEM); }
#line 5497 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 381:
#line 1903 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *range = checkRange(astbuf1, (yyvsp[0].ast));
		if (range)
			astbuf1->children.push_back(range);
	}
#line 5507 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 382:
#line 1908 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
	}
#line 5515 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 383:
#line 1910 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
			// stash state on ast_stack
			ast_stack.push_back(astbuf2);
			astbuf2 = (yyvsp[0].ast);
		}
#line 5525 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 384:
#line 1914 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		        astbuf1 = astbuf2;
			// recover state
			astbuf2 = ast_stack.back();
			ast_stack.pop_back();
		}
#line 5536 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 387:
#line 1924 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { addWiretypeNode((yyvsp[0].string), astbuf1); }
#line 5542 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 390:
#line 1931 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {	auto *var_node = astbuf2->clone();
				var_node->str = *(yyvsp[0].string);
				delete (yyvsp[0].string);
				SET_AST_NODE_LOC(var_node, (yylsp[0]), (yylsp[0]));
				ast_stack.back()->children.push_back(var_node);
			}
#line 5553 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 391:
#line 1944 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
	}
#line 5563 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 392:
#line 1948 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 5574 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 394:
#line 1954 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(0, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5587 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 396:
#line 1962 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(1, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5600 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 399:
#line 1973 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *wire_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-2)->clone();
		AstNode *assign_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-1)->clone();
		wire_node->str = *(yyvsp[0].string);
		assign_node->children[0]->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(wire_node);
		ast_stack.back()->children.push_back(assign_node);
		delete (yyvsp[0].string);
	}
#line 5614 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 402:
#line 1987 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		bool attr_anyconst = false;
		bool attr_anyseq = false;
		bool attr_allconst = false;
		bool attr_allseq = false;
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyconst);
			ast_stack.back()->children.back()->attributes.erase(ID::anyconst);
			attr_anyconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyseq);
			ast_stack.back()->children.back()->attributes.erase(ID::anyseq);
			attr_anyseq = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allconst);
			ast_stack.back()->children.back()->attributes.erase(ID::allconst);
			attr_allconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allseq);
			ast_stack.back()->children.back()->attributes.erase(ID::allseq);
			attr_allseq = true;
		}
		if (current_wire_rand || attr_anyconst || attr_anyseq || attr_allconst || attr_allseq) {
			AstNode *wire = new AstNode(AST_IDENTIFIER);
			AstNode *fcall = new AstNode(AST_FCALL);
			wire->str = ast_stack.back()->children.back()->str;
			fcall->str = current_wire_const ? "\\$anyconst" : "\\$anyseq";
			if (attr_anyconst)
				fcall->str = "\\$anyconst";
			if (attr_anyseq)
				fcall->str = "\\$anyseq";
			if (attr_allconst)
				fcall->str = "\\$allconst";
			if (attr_allseq)
				fcall->str = "\\$allseq";
			fcall->attributes[ID::reg] = AstNode::mkconst_str(RTLIL::unescape_id(wire->str));
			ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, fcall));
		}
	}
#line 5661 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 403:
#line 2029 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *wire = new AstNode(AST_IDENTIFIER);
		wire->str = ast_stack.back()->children.back()->str;
		if (astbuf1->is_input) {
			if (astbuf1->attributes.count(ID::defaultvalue))
				delete astbuf1->attributes.at(ID::defaultvalue);
			astbuf1->attributes[ID::defaultvalue] = (yyvsp[0].ast);
		}
		else if (astbuf1->is_reg || astbuf1->is_logic){
			AstNode *assign = new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast));
			AstNode *block = new AstNode(AST_BLOCK, assign);
			AstNode *init = new AstNode(AST_INITIAL, block);

			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(block, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(init, (yylsp[-2]), (yylsp[0]));

			ast_stack.back()->children.push_back(init);
		}
		else {
			AstNode *assign = new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast));
			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			ast_stack.back()->children.push_back(assign);
		}

	}
#line 5692 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 404:
#line 2057 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (astbuf1 == nullptr)
			frontend_verilog_yyerror("Internal error - should not happen - no AST_WIRE node.");
		AstNode *node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		append_attr_clone(node, albuf);
		if (astbuf2 != NULL)
			node->children.push_back(astbuf2->clone());
		if ((yyvsp[0].ast) != NULL) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("input/output/inout ports cannot have unpacked dimensions.");
			if (!astbuf2 && !node->is_custom_type) {
				addRange(node, 0, 0, false);
			}
			rewriteAsMemoryNode(node, (yyvsp[0].ast));
		}
		if (current_function_or_task) {
			if (node->is_input || node->is_output)
				node->port_id = current_function_or_task_port_id++;
		} else if (ast_stack.back()->type == AST_GENBLOCK) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("Cannot declare module port `%s' within a generate block.", (yyvsp[-1].string)->c_str());
		} else {
			if (do_not_require_port_stubs && (node->is_input || node->is_output) && port_stubs.count(*(yyvsp[-1].string)) == 0) {
				port_stubs[*(yyvsp[-1].string)] = ++port_counter;
			}
			if (port_stubs.count(*(yyvsp[-1].string)) != 0) {
				if (!node->is_input && !node->is_output)
					frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[-1].string)->c_str());
				if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
					frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[-1].string)->c_str());
				node->port_id = port_stubs[*(yyvsp[-1].string)];
				port_stubs.erase(*(yyvsp[-1].string));
			} else {
				if (node->is_input || node->is_output)
					frontend_verilog_yyerror("Module port `%s' is not declared in module header.", (yyvsp[-1].string)->c_str());
			}
		}
		//FIXME: for some reason, TOK_ID has a location which always points to one column *after* the real last column...
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);

		delete (yyvsp[-1].string);
	}
#line 5741 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 408:
#line 2109 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ASSIGN, (yyvsp[-2].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC(node, (yyloc), (yyloc));
		ast_stack.back()->children.push_back(node);
	}
#line 5751 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 410:
#line 2116 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { if (isInLocalScope((yyvsp[0].string))) frontend_verilog_yyerror("Duplicate declaration of TYPEDEF '%s'", (yyvsp[0].string)->c_str()+1); }
#line 5757 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 411:
#line 2120 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = (yyvsp[-4].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[-3].ast));
		if (astbuf2)
			astbuf1->children.push_back(astbuf2);

		if ((yyvsp[-1].ast) != NULL) {
			if (!astbuf2 && !astbuf1->is_custom_type) {
				addRange(astbuf1, 0, 0, false);
			}
			rewriteAsMemoryNode(astbuf1, (yyvsp[-1].ast));
		}
		addTypedefNode((yyvsp[-2].string), astbuf1); }
#line 5775 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 412:
#line 2133 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { addTypedefNode((yyvsp[-1].string), (yyvsp[-2].ast)); }
#line 5781 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 413:
#line 2137 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		addWiretypeNode((yyvsp[0].string), (yyval.ast));
	}
#line 5791 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 414:
#line 2142 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_WIRE);
		if ((yyvsp[-1].integer) == TOK_REG) {
			(yyval.ast)->is_reg = true;
		} else {
			(yyval.ast)->is_logic = true;
		}
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
	}
#line 5805 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 415:
#line 2151 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
		(yyval.ast)->range_left = (yyvsp[-1].integer) - 1;
		(yyval.ast)->range_right = 0;
	}
#line 5817 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 418:
#line 2165 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = new AstNode(AST_CELL);
		append_attr(astbuf1, (yyvsp[-1].al));
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5829 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 419:
#line 2171 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
	}
#line 5837 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 420:
#line 2174 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf1 = new AstNode(AST_PRIMITIVE);
		astbuf1->str = *(yyvsp[-1].string);
		append_attr(astbuf1, (yyvsp[-2].al));
		delete (yyvsp[-1].string);
	}
#line 5848 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 421:
#line 2179 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete astbuf1;
	}
#line 5856 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 422:
#line 2184 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = (yyvsp[0].string);
	}
#line 5864 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 423:
#line 2187 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = new std::string("or");
	}
#line 5872 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 428:
#line 2199 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 5884 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 429:
#line 2205 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-4]), (yyloc));
	}
#line 5892 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 430:
#line 2210 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.back()->children.push_back(new AstNode(AST_CELLARRAY, (yyvsp[0].ast), astbuf2));
	}
#line 5904 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 431:
#line 2216 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-5]), (yyloc));
	}
#line 5912 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 437:
#line 2230 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		astbuf2 = astbuf1->clone();
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 5921 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 438:
#line 2233 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-3]), (yyloc));
	}
#line 5929 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 444:
#line 2245 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_PARASET);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 5939 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 445:
#line 2250 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// just ignore empty parameters
	}
#line 5947 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 446:
#line 2253 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_PARASET);
		node->str = *(yyvsp[-3].string);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
	}
#line 5959 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 447:
#line 2262 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		// remove empty args from end of list
		while (!astbuf2->children.empty()) {
			AstNode *node = astbuf2->children.back();
			if (node->type != AST_ARGUMENT) break;
			if (!node->children.empty()) break;
			if (!node->str.empty()) break;
			astbuf2->children.pop_back();
			delete node;
		}

		// check port types
		bool has_positional_args = false;
		bool has_named_args = false;
		for (auto node : astbuf2->children) {
			if (node->type != AST_ARGUMENT) continue;
			if (node->str.empty())
				has_positional_args = true;
			else
				has_named_args = true;
		}

		if (has_positional_args && has_named_args)
			frontend_verilog_yyerror("Mix of positional and named cell ports.");
	}
#line 5989 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 450:
#line 2292 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		free_attr((yyvsp[0].al));
	}
#line 5999 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 451:
#line 2297 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
		free_attr((yyvsp[-1].al));
	}
#line 6010 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 452:
#line 2303 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-3].string);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
		free_attr((yyvsp[-5].al));
	}
#line 6023 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 453:
#line 2311 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-2].string);
		astbuf2->children.push_back(node);
		delete (yyvsp[-2].string);
		free_attr((yyvsp[-4].al));
	}
#line 6035 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 454:
#line 2318 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[0].string);
		astbuf2->children.push_back(node);
		node->children.push_back(new AstNode(AST_IDENTIFIER));
		node->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		free_attr((yyvsp[-2].al));
	}
#line 6049 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 455:
#line 2327 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Wildcard port connections are only supported in SystemVerilog mode.");
		astbuf2->attributes[ID::wildcard_port_conns] = AstNode::mkconst_int(1, false);
		free_attr((yyvsp[-1].al));
	}
#line 6060 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 456:
#line 2335 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = false;
	}
#line 6068 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 457:
#line 2338 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = true;
	}
#line 6076 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 458:
#line 2343 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = false;
	}
#line 6084 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 459:
#line 2346 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = true;
	}
#line 6092 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 460:
#line 2351 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_ff] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 6105 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 461:
#line 2358 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6115 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 462:
#line 2362 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();

		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-4]), (yyloc));
		ast_stack.pop_back();

		SET_RULE_LOC((yyloc), (yylsp[-4]), (yyloc));
	}
#line 6129 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 463:
#line 2371 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_latch] = AstNode::mkconst_int(1, false);
		else
			node->attributes[ID::always_comb] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6147 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 464:
#line 2383 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6156 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 465:
#line 2387 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_INITIAL);
		append_attr(node, (yyvsp[-1].al));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6170 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 466:
#line 2395 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6179 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 476:
#line 2414 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_POSEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6190 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 477:
#line 2420 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_NEGEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6201 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 478:
#line 2426 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_EDGE);
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6211 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 479:
#line 2433 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6219 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 480:
#line 2436 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = NULL;
	}
#line 6227 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 481:
#line 2441 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = (yyvsp[-1].string);
	}
#line 6235 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 482:
#line 2444 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.string) = NULL;
	}
#line 6243 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 483:
#line 2449 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = true;
	}
#line 6251 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 484:
#line 2452 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = false;
	}
#line 6259 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 485:
#line 2455 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.boolean) = false;
	}
#line 6267 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 486:
#line 2460 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
        AstNode *modport = new AstNode(AST_MODPORT);
        ast_stack.back()->children.push_back(modport);
        ast_stack.push_back(modport);
        modport->str = *(yyvsp[0].string);
        delete (yyvsp[0].string);
    }
#line 6279 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 487:
#line 2466 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
        ast_stack.pop_back();
        log_assert(ast_stack.size() == 2);
    }
#line 6288 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 495:
#line 2482 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
        AstNode *modport_member = new AstNode(AST_MODPORTMEMBER);
        ast_stack.back()->children.push_back(modport_member);
        modport_member->str = *(yyvsp[0].string);
        modport_member->is_input = current_modport_input;
        modport_member->is_output = current_modport_output;
        delete (yyvsp[0].string);
    }
#line 6301 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 496:
#line 2492 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {current_modport_input = 1; current_modport_output = 0;}
#line 6307 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 497:
#line 2492 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {current_modport_input = 0; current_modport_output = 1;}
#line 6313 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 498:
#line 2495 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-6].string) != nullptr ? (yylsp[-6]) : (yylsp[-5])), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6331 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 499:
#line 2508 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_ASSERT : AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-6].string) != nullptr ? (yylsp[-6]) : (yylsp[-5])), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6349 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 500:
#line 2521 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-7].string) != nullptr ? (yylsp[-7]) : (yylsp[-6])), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6367 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 501:
#line 2534 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_LIVE : AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-7].string) != nullptr ? (yylsp[-7]) : (yylsp[-6])), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6385 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 502:
#line 2547 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, ((yyvsp[-6].string) != nullptr ? (yylsp[-6]) : (yylsp[-5])), (yylsp[-1]));
		if ((yyvsp[-6].string) != nullptr) {
			node->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6399 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 503:
#line 2556 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, ((yyvsp[-5].string) != nullptr ? (yylsp[-5]) : (yylsp[-4])), (yylsp[-1]));
		if ((yyvsp[-5].string) != nullptr) {
			node->str = *(yyvsp[-5].string);
			delete (yyvsp[-5].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6413 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 504:
#line 2565 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, ((yyvsp[-2].string) != nullptr ? (yylsp[-2]) : (yylsp[-1])), (yylsp[-1]));
		if ((yyvsp[-2].string) != nullptr) {
			node->str = *(yyvsp[-2].string);
			delete (yyvsp[-2].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6427 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 505:
#line 2574 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-6].string) != nullptr ? (yylsp[-6]) : (yylsp[-5])), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-4].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6447 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 506:
#line 2589 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, ((yyvsp[-7].string) != nullptr ? (yylsp[-7]) : (yylsp[-6])), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-5].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6467 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 507:
#line 2606 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6481 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 508:
#line 2615 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6495 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 509:
#line 2624 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6509 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 510:
#line 2633 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6523 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 511:
#line 2642 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6537 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 512:
#line 2651 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-6].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
				delete (yyvsp[-6].string);
			}
		}
	}
#line 6555 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 513:
#line 2664 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-7].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
				delete (yyvsp[-7].string);
			}
		}
	}
#line 6573 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 514:
#line 2679 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6584 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 515:
#line 2685 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addIncOrDecStmt((yyvsp[-3].al), (yyvsp[-2].ast), (yyvsp[-1].al), (yyvsp[0].ast_node_type), (yylsp[-3]), (yylsp[0]));
	}
#line 6592 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 516:
#line 2688 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addIncOrDecStmt((yyvsp[-3].al), (yyvsp[0].ast), (yyvsp[-1].al), (yyvsp[-2].ast_node_type), (yylsp[-3]), (yylsp[0]));
	}
#line 6600 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 517:
#line 2691 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ASSIGN_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6611 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 518:
#line 2697 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		addAsgnBinopStmt((yyvsp[-4].al), (yyvsp[-3].ast), (yyvsp[-2].ast_node_type), (yyvsp[0].ast), (yylsp[-3]), (yylsp[0]));
	}
#line 6619 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 519:
#line 2702 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_BIT_OR; }
#line 6625 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 520:
#line 2703 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_BIT_AND; }
#line 6631 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 521:
#line 2704 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_BIT_XOR; }
#line 6637 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 522:
#line 2705 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_ADD; }
#line 6643 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 523:
#line 2706 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SUB; }
#line 6649 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 524:
#line 2707 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_DIV; }
#line 6655 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 525:
#line 2708 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_MOD; }
#line 6661 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 526:
#line 2709 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_MUL; }
#line 6667 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 527:
#line 2710 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SHIFT_LEFT; }
#line 6673 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 528:
#line 2711 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SHIFT_RIGHT; }
#line 6679 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 529:
#line 2712 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SHIFT_SLEFT; }
#line 6685 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 530:
#line 2713 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SHIFT_SRIGHT; }
#line 6691 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 531:
#line 2718 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_ADD; }
#line 6697 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 532:
#line 2719 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.ast_node_type) = AST_SUB; }
#line 6703 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 533:
#line 2722 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		AstNode *node = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
		delete (yyvsp[-2].string);
	}
#line 6716 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 534:
#line 2730 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		frontend_verilog_yyerror("For loop variable declaration is missing initialization!");
	}
#line 6724 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 535:
#line 2733 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("For loop inline variable declaration is only supported in SystemVerilog mode!");

		// loop variable declaration
		AstNode *wire = (yyvsp[-4].ast);
		AstNode *range = checkRange(wire, (yyvsp[-3].ast));
		if (range != nullptr)
			wire->children.push_back(range);
		SET_AST_NODE_LOC(wire, (yylsp[-4]), (yylsp[-2]));
		SET_AST_NODE_LOC(range, (yylsp[-3]), (yylsp[-3]));

		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		wire->str = *(yyvsp[-2].string);
		delete (yyvsp[-2].string);

		AstNode *loop = ast_stack.back();
		AstNode *parent = ast_stack.at(ast_stack.size() - 2);
		log_assert(parent->children.back() == loop);

		// loop variable initialization
		AstNode *asgn = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		loop->children.push_back(asgn);
		SET_AST_NODE_LOC(asgn, (yylsp[-2]), (yylsp[0]));
		SET_AST_NODE_LOC(ident, (yylsp[-2]), (yylsp[-2]));

		// inject a wrapping block to declare the loop variable and
		// contain the current loop
		AstNode *wrapper = new AstNode(AST_BLOCK);
		wrapper->str = "$fordecl_block$" + std::to_string(autoidx++);
		wrapper->children.push_back(wire);
		wrapper->children.push_back(loop);
		parent->children.back() = wrapper; // replaces `loop`
	}
#line 6764 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 544:
#line 2774 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		free_attr((yyvsp[-1].al));
	}
#line 6772 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 545:
#line 2777 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6785 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 546:
#line 2784 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6794 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 547:
#line 2788 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6807 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 548:
#line 2795 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6816 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 549:
#line 2799 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		enterTypeScope();
	}
#line 6824 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 550:
#line 2801 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		if ((yyvsp[0].string) != NULL)
			node->str = *(yyvsp[0].string);
	}
#line 6837 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 551:
#line 2808 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		AstNode *node = ast_stack.back();
		// In SystemVerilog, unnamed blocks with block item declarations
		// create an implicit hierarchy scope
		if (sv_mode && node->str.empty())
		    for (const AstNode* child : node->children)
			if (child->type == AST_WIRE || child->type == AST_MEMORY || child->type == AST_PARAMETER
				|| child->type == AST_LOCALPARAM || child->type == AST_TYPEDEF) {
			    node->str = "$unnamed_block$" + std::to_string(autoidx++);
			    break;
			}
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		ast_stack.pop_back();
	}
#line 6860 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 552:
#line 2826 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_FOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-2].al));
	}
#line 6871 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 553:
#line 2831 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 6879 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 554:
#line 2833 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *block = new AstNode(AST_BLOCK);
		block->str = "$for_loop$" + std::to_string(autoidx++);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6890 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 555:
#line 2838 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-11]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6901 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 556:
#line 2844 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_WHILE);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6916 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 557:
#line 2853 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6926 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 558:
#line 2858 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_REPEAT);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6941 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 559:
#line 2867 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6951 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 560:
#line 2872 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_CASE);
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, AstNode::mkconst_int(1, false, 1), block);
		SET_AST_NODE_LOC(cond, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back(new AstNode(AST_REDUCE_BOOL, (yyvsp[-1].ast)));
		node->children.push_back(cond);
		ast_stack.push_back(node);
		ast_stack.push_back(block);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6968 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 561:
#line 2883 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 6976 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 562:
#line 2885 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6986 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 563:
#line 2890 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_CASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-1]), (yylsp[-1]));
	}
#line 6998 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 564:
#line 2896 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7008 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 565:
#line 2903 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.al) = (yyvsp[0].al);
	}
#line 7016 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 566:
#line 2906 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7025 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 567:
#line 2910 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7034 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 568:
#line 2914 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7044 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 569:
#line 2921 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.push_back(0);
	}
#line 7052 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 570:
#line 2924 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.push_back('x');
	}
#line 7060 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 571:
#line 2927 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.push_back('z');
	}
#line 7068 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 572:
#line 2932 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (ast_stack.back()->attributes.count(ID::full_case) == 0)
			ast_stack.back()->attributes[ID::full_case] = AstNode::mkconst_int(1, false);
	}
#line 7077 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 573:
#line 2936 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (ast_stack.back()->attributes.count(ID::parallel_case) == 0)
			ast_stack.back()->attributes[ID::parallel_case] = AstNode::mkconst_int(1, false);
	}
#line 7086 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 577:
#line 2947 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, new AstNode(AST_DEFAULT), block);
		SET_AST_NODE_LOC(cond, (yylsp[0]), (yylsp[0]));

		ast_stack.pop_back();
		ast_stack.back()->children.push_back(cond);
		ast_stack.push_back(block);
	}
#line 7100 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 578:
#line 2955 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7108 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 582:
#line 2965 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7120 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 583:
#line 2971 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
		case_type_stack.push_back(0);
	}
#line 7131 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 584:
#line 2976 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7142 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 587:
#line 2988 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7154 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 588:
#line 2994 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.push_back(0);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7163 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 589:
#line 2997 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7172 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 592:
#line 3007 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_DEFAULT);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
	}
#line 7182 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 593:
#line 3012 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_IDENTIFIER);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7194 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 594:
#line 3019 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7202 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 595:
#line 3022 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7210 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 596:
#line 3027 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_PREFIX, (yyvsp[-3].ast), (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-5].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yylsp[0]));
		delete (yyvsp[-5].string);
	}
#line 7221 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 597:
#line 3033 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
		if ((yyvsp[0].ast) == nullptr && ((yyval.ast)->str == "\\$initstate" ||
				(yyval.ast)->str == "\\$anyconst" || (yyval.ast)->str == "\\$anyseq" ||
				(yyval.ast)->str == "\\$allconst" || (yyval.ast)->str == "\\$allseq"))
			(yyval.ast)->type = AST_FCALL;
	}
#line 7236 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 598:
#line 3043 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
	}
#line 7247 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 599:
#line 3051 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7255 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 600:
#line 3054 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7263 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 601:
#line 3059 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_CONCAT);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 7272 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 602:
#line 3063 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 7281 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 609:
#line 3081 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7289 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 615:
#line 3092 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		free_attr((yyvsp[-1].al));
	}
#line 7297 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 616:
#line 3097 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_IDENTIFIER);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7307 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 617:
#line 3104 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		frontend_verilog_yyerror("Generate for loop variable declaration is missing initialization!");
	}
#line 7315 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 618:
#line 3107 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Generate for loop inline variable declaration is only supported in SystemVerilog mode!");
		AstNode *node = new AstNode(AST_GENVAR);
		node->is_reg = true;
		node->is_signed = true;
		node->range_left = 31;
		node->range_right = 0;
		node->str = (yyvsp[-2].ast)->str;
		node->children.push_back(checkRange(node, nullptr));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
	}
#line 7336 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 619:
#line 3123 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
	}
#line 7346 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 620:
#line 3131 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENFOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7356 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 621:
#line 3135 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7364 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 622:
#line 3137 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-10]), (yylsp[0]));
		rewriteGenForDeclInit(ast_stack.back());
		ast_stack.pop_back();
	}
#line 7374 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 623:
#line 3142 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENIF);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
	}
#line 7385 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 624:
#line 3147 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7394 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 625:
#line 3151 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENCASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7404 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 626:
#line 3155 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7414 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 627:
#line 3160 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_TECALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7426 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 628:
#line 3166 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[-1]));
		ast_stack.pop_back();
	}
#line 7435 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 629:
#line 3172 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		enterTypeScope();
	}
#line 7443 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 630:
#line 3174 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = (yyvsp[0].string) ? *(yyvsp[0].string) : std::string();
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7454 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 631:
#line 3179 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7467 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 632:
#line 3190 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7477 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 633:
#line 3194 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7486 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 637:
#line 3203 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7494 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 638:
#line 3206 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_TERNARY);
		(yyval.ast)->children.push_back((yyvsp[-5].ast));
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
		(yyval.ast)->children.push_back((yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yyloc));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7507 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 639:
#line 3214 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = addIncOrDecExpr((yyvsp[0].ast), (yyvsp[-1].al), (yyvsp[-2].ast_node_type), (yylsp[-2]), (yylsp[0]), false);
	}
#line 7515 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 640:
#line 3219 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = addIncOrDecExpr((yyvsp[-1].ast), nullptr, (yyvsp[0].ast_node_type), (yylsp[-1]), (yylsp[0]), true);
	}
#line 7523 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 641:
#line 3224 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7531 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 642:
#line 3227 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants e.g. (<expr>)<constval> , while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = (yyvsp[-2].ast);
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[0].string);
	}
#line 7546 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 643:
#line 3237 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants, e.g. <ID>\'d0, while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = new AstNode(AST_IDENTIFIER);
		bits->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC(bits, (yylsp[-1]), (yylsp[-1]));
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC(val, (yylsp[0]), (yylsp[0]));
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7565 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 644:
#line 3251 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		if ((yyval.ast) == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		delete (yyvsp[0].string);
	}
#line 7577 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 645:
#line 3258 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REALVALUE);
		char *p = (char*)malloc(GetSize(*(yyvsp[0].string)) + 1), *q;
		for (int i = 0, j = 0; j < GetSize(*(yyvsp[0].string)); j++)
			if ((*(yyvsp[0].string))[j] != '_')
				p[i++] = (*(yyvsp[0].string))[j], p[i] = 0;
		(yyval.ast)->realvalue = strtod(p, &q);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		log_assert(*q == 0);
		delete (yyvsp[0].string);
		free(p);
	}
#line 7594 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 646:
#line 3270 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = AstNode::mkconst_str(*(yyvsp[0].string));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		delete (yyvsp[0].string);
	}
#line 7604 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 647:
#line 3275 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		AstNode *node = new AstNode(AST_FCALL);
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		append_attr(node, (yyvsp[0].al));
	}
#line 7617 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 648:
#line 3282 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = ast_stack.back();
		ast_stack.pop_back();
	}
#line 7626 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 649:
#line 3286 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7635 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 650:
#line 3290 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7644 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 651:
#line 3294 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7652 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 652:
#line 3297 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		delete (yyvsp[-5].ast);
		(yyval.ast) = (yyvsp[-3].ast);
		delete (yyvsp[-1].ast);
	}
#line 7662 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 653:
#line 3302 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7670 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 654:
#line 3305 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REPLICATE, (yyvsp[-4].ast), (yyvsp[-2].ast));
	}
#line 7678 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 655:
#line 3308 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7688 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 656:
#line 3313 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7698 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 657:
#line 3318 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7708 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 658:
#line 3323 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7718 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 659:
#line 3328 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7728 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 660:
#line 3333 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_XOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7738 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 661:
#line 3338 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_BIT_XNOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7748 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 662:
#line 3343 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7758 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 663:
#line 3348 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
	}
#line 7769 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 664:
#line 3354 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7779 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 665:
#line 3359 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
	}
#line 7791 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 666:
#line 3366 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_XOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7801 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 667:
#line 3371 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_REDUCE_XNOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7811 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 668:
#line 3376 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_SHIFT_LEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7821 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 669:
#line 3381 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_SHIFT_RIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7831 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 670:
#line 3386 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_SHIFT_SLEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7841 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 671:
#line 3391 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_SHIFT_SRIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7851 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 672:
#line 3396 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_LT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7861 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 673:
#line 3401 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7871 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 674:
#line 3406 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7881 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 675:
#line 3411 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_NE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7891 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 676:
#line 3416 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_EQX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7901 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 677:
#line 3421 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_NEX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7911 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 678:
#line 3426 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_GE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7921 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 679:
#line 3431 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_GT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7931 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 680:
#line 3436 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_ADD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7941 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 681:
#line 3441 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_SUB, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7951 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 682:
#line 3446 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_MUL, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7961 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 683:
#line 3451 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_DIV, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7971 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 684:
#line 3456 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_MOD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7981 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 685:
#line 3461 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_POW, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7991 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 686:
#line 3466 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_POS, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8001 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 687:
#line 3471 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_NEG, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8011 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 688:
#line 3476 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_LOGIC_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8021 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 689:
#line 3481 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_LOGIC_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8031 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 690:
#line 3486 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8041 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 691:
#line 3491 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8052 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 692:
#line 3497 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8063 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 693:
#line 3503 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_CAST_SIZE, (yyvsp[-4].ast), (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8074 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 694:
#line 3509 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_CAST_SIZE, (yyvsp[-4].ast), (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8085 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 695:
#line 3515 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ensureAsgnExprAllowed();
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[-1]));
		(yyval.ast) = (yyvsp[-3].ast)->clone();
	}
#line 8097 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 696:
#line 3522 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		ensureAsgnExprAllowed();
		(yyval.ast) = addAsgnBinopStmt(nullptr, (yyvsp[-3].ast), (yyvsp[-2].ast_node_type), (yyvsp[-1].ast), (yylsp[-3]), (yylsp[-1]))-> clone();
	}
#line 8106 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 697:
#line 3528 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = new AstNode(AST_CONCAT, (yyvsp[0].ast));
	}
#line 8114 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 698:
#line 3531 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 8123 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 699:
#line 3537 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 8129 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 700:
#line 3538 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 8135 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 701:
#line 3539 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyvsp[-1].string)->append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8145 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;

  case 702:
#line 3544 "frontends/verilog/verilog_parser.y" /* yacc.c:1646  */
    {
		(yyvsp[-2].string)->append(*(yyvsp[-1].string)).append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-2].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8156 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
    break;


#line 8160 "frontends/verilog/verilog_parser.tab.cc" /* yacc.c:1646  */
        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyesa, &yyes, &yyes_capacity, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
